#include "ID2Str.h"

const WRL_String ID2Chars(WRL_DWord id)
{
    static unsigned char result[5];
    result[4] = 0;
    result[0] = id >> 24;
    result[1] = (id >> 16) & 0xFF;
    result[2] = (id >> 8) & 0xFF;
    result[3] = id & 0xFF;
    return result;
}

const char * ID2Str(WRL_DWord id)
{
    switch(id)
    {
        case 0x000D0002: return "Issue Order: (smart) ";
        case 0x000D0003: return "Issue Order: smart";
        case 0x000D0004: return "Issue Order: stop";
        case 0x000D0005: return "Issue Order: (stop) ";
        case 0x000D0007: return "Issue Order: (stop) ";
        case 0x000D0008: return "Issue Order: (cancel)";
        case 0x000D000C: return "Issue Order: setrally";
        case 0x000D000D: return "Issue Order: getitem";
        case 0x000D000F: return "Issue Order: attack";
        case 0x000D0010: return "Issue Order: attackgrouned";
        case 0x000D0011: return "Issue Order: attackonce";
        case 0x000D0012: return "Issue Order: move";
        case 0x000D0013: return "Issue Order: (stop) ";
        case 0x000D0014: return "Issue Order: AImove";
        case 0x000D0016: return "Issue Order: patrol";
        case 0x000D0017: return "Issue Order: (shakebody) ";
        case 0x000D0019: return "Issue Order: holdposition";
        case 0x000D001A: return "Issue Order: build";
        case 0x000D001B: return "Issue Order: humanbuild";
        case 0x000D001C: return "Issue Order: orcbuild";
        case 0x000D001D: return "Issue Order: nightelfbuild";
        case 0x000D001E: return "Issue Order: undeadbuild";
        case 0x000D001F: return "Issue Order: resumebuild";
        case 0x000D0021: return "Issue Order: dropitem";
        case 0x000D0022: return "Issue Order: (putitem1)";
        case 0x000D0023: return "Issue Order: (putitem2)";
        case 0x000D0024: return "Issue Order: (putitem3)";
        case 0x000D0025: return "Issue Order: (putitem4)";
        case 0x000D0026: return "Issue Order: (putitem5)";
        case 0x000D0027: return "Issue Order: (putitem6)";
        case 0x000D0028: return "Issue Order: (useitem1)";
        case 0x000D0029: return "Issue Order: (useitem2)";
        case 0x000D002A: return "Issue Order: (useitem3)";
        case 0x000D002B: return "Issue Order: (useitem4)";
        case 0x000D002C: return "Issue Order: (useitem5)";
        case 0x000D002D: return "Issue Order: (useitem6)";
        case 0x000D002F: return "Issue Order: detectaoe";
        case 0x000D0031: return "Issue Order: resumeharvesting";
        case 0x000D0032: return "Issue Order: harvest";
        case 0x000D0033: return "Issue Order: (harvest)";
        case 0x000D0034: return "Issue Order: returnresources";
        case 0x000D0035: return "Issue Order: autoharvestgold";
        case 0x000D0036: return "Issue Order: autoharvestlumber";
        case 0x000D0037: return "Issue Order: neutraldetectaoe";
        case 0x000D0038: return "Issue Order: repair";
        case 0x000D0039: return "Issue Order: repairon";
        case 0x000D003A: return "Issue Order: repairoff";
        case 0x000D003B: return "Issue Order: (revivehero1)";
        case 0x000D003C: return "Issue Order: (revivehero2)";
        case 0x000D003D: return "Issue Order: (revivehero3)";
        case 0x000D003E: return "Issue Order: (revivehero4)";
        case 0x000D003F: return "Issue Order: (revivehero5)";
        case 0x000D0047: return "Issue Order: revive";
        case 0x000D0048: return "Issue Order: selfdestruct";
        case 0x000D0049: return "Issue Order: selfdestructon";
        case 0x000D004A: return "Issue Order: selfdestructoff";
        case 0x000D004B: return "Issue Order: board";
        case 0x000D004C: return "Issue Order: forceboard";
        case 0x000D004E: return "Issue Order: load";
        case 0x000D004F: return "Issue Order: unload";
        case 0x000D0050: return "Issue Order: unloadall";
        case 0x000D0051: return "Issue Order: unloadallinstant";
        case 0x000D0052: return "Issue Order: loadcorpse";
        case 0x000D0055: return "Issue Order: loadcorpseinstant";
        case 0x000D0056: return "Issue Order: unloadallcorpses";
        case 0x000D0057: return "Issue Order: defend";
        case 0x000D0058: return "Issue Order: undefend";
        case 0x000D0059: return "Issue Order: dispel";
        case 0x000D005C: return "Issue Order: flare";
        case 0x000D005F: return "Issue Order: heal";
        case 0x000D0060: return "Issue Order: healon";
        case 0x000D0061: return "Issue Order: healoff";
        case 0x000D0062: return "Issue Order: innerfire";
        case 0x000D0063: return "Issue Order: innerfireon";
        case 0x000D0064: return "Issue Order: innerfireoff";
        case 0x000D0065: return "Issue Order: invisibility";
        case 0x000D0067: return "Issue Order: militiaconvert";
        case 0x000D0068: return "Issue Order: militia";
        case 0x000D0069: return "Issue Order: militiaoff";
        case 0x000D006A: return "Issue Order: polymorph";
        case 0x000D006B: return "Issue Order: slow";
        case 0x000D006C: return "Issue Order: slowon";
        case 0x000D006D: return "Issue Order: slowoff";
        case 0x000D006F: return "Issue Order: tankdroppilot";
        case 0x000D0070: return "Issue Order: tankloadpilot";
        case 0x000D0071: return "Issue Order: tankpilot";
        case 0x000D0072: return "Issue Order: townbellon";
        case 0x000D0073: return "Issue Order: townbelloff";
        case 0x000D0076: return "Issue Order: avatar";
        case 0x000D0077: return "Issue Order: unavatar";
        case 0x000D0079: return "Issue Order: blizzard";
        case 0x000D007A: return "Issue Order: divineshield";
        case 0x000D007B: return "Issue Order: undivineshield";
        case 0x000D007C: return "Issue Order: holybolt";
        case 0x000D007D: return "Issue Order: massteleport";
        case 0x000D007E: return "Issue Order: resurrection";
        case 0x000D007F: return "Issue Order: thunderbold";
        case 0x000D0080: return "Issue Order: thunderclap";
        case 0x000D0081: return "Issue Order: waterelemental";
        case 0x000D0083: return "Issue Order: battlestations";
        case 0x000D0084: return "Issue Order: berserk";
        case 0x000D0085: return "Issue Order: bloodlust";
        case 0x000D0086: return "Issue Order: bloodluston";
        case 0x000D0087: return "Issue Order: bloodlustoff";
        case 0x000D0088: return "Issue Order: devour";
        case 0x000D0089: return "Issue Order: evileye";
        case 0x000D008A: return "Issue Order: ensnare";
        case 0x000D008B: return "Issue Order: ensnareon";
        case 0x000D008C: return "Issue Order: ensnareoff";
        case 0x000D008D: return "Issue Order: healingward";
        case 0x000D008E: return "Issue Order: lightningshield";
        case 0x000D008F: return "Issue Order: purge";
        case 0x000D0091: return "Issue Order: standdown";
        case 0x000D0092: return "Issue Order: stasistrap";
        case 0x000D0097: return "Issue Order: chainlightning";
        case 0x000D0099: return "Issue Order: earthquake";
        case 0x000D009A: return "Issue Order: farsight";
        case 0x000D009B: return "Issue Order: mirrorimage";
        case 0x000D009D: return "Issue Order: shockwave";
        case 0x000D009E: return "Issue Order: spiritwolf";
        case 0x000D009F: return "Issue Order: stomp";
        case 0x000D00A0: return "Issue Order: whirlwind";
        case 0x000D00A1: return "Issue Order: windwalk";
        case 0x000D00A2: return "Issue Order: unwindwalk";
        case 0x000D00A3: return "Issue Order: ambush";
        case 0x000D00A4: return "Issue Order: autodispel";
        case 0x000D00A5: return "Issue Order: autodispelon";
        case 0x000D00A6: return "Issue Order: autodispeloff";
        case 0x000D00A7: return "Issue Order: barkskin";
        case 0x000D00A8: return "Issue Order: barkskinon";
        case 0x000D00A9: return "Issue Order: barkskinoff";
        case 0x000D00AA: return "Issue Order: bearform";
        case 0x000D00AB: return "Issue Order: unbearform";
        case 0x000D00AC: return "Issue Order: corrosivebreath";
        case 0x000D00AE: return "Issue Order: loadarcher";
        case 0x000D00AF: return "Issue Order: mounthippogryph";
        case 0x000D00B0: return "Issue Order: cyclone";
        case 0x000D00B1: return "Issue Order: detonate";
        case 0x000D00B2: return "Issue Order: eattree";
        case 0x000D00B3: return "Issue Order: entangle";
        case 0x000D00B4: return "Issue Order: entangleinstant";
        case 0x000D00B5: return "Issue Order: faeriefire";
        case 0x000D00B6: return "Issue Order: faeriefireon";
        case 0x000D00B7: return "Issue Order: faeriefireoff";
        case 0x000D00BB: return "Issue Order: ravenform";
        case 0x000D00BC: return "Issue Order: unravenform";
        case 0x000D00BD: return "Issue Order: recharge";
        case 0x000D00BE: return "Issue Order: rechargeon";
        case 0x000D00BF: return "Issue Order: rechargeoff";
        case 0x000D00C0: return "Issue Order: rejuvination";
        case 0x000D00C1: return "Issue Order: renew";
        case 0x000D00C2: return "Issue Order: renewon";
        case 0x000D00C3: return "Issue Order: renewoff";
        case 0x000D00C4: return "Issue Order: roar";
        case 0x000D00C5: return "Issue Order: root";
        case 0x000D00C6: return "Issue Order: unroot";
        case 0x000D00CB: return "Issue Order: entanglingroots";
        case 0x000D00CD: return "Issue Order: flamingarrowstarg";
        case 0x000D00CE: return "Issue Order: flamingarrows";
        case 0x000D00CF: return "Issue Order: unflamingarrows";
        case 0x000D00D0: return "Issue Order: forceofnature";
        case 0x000D00D1: return "Issue Order: immolation";
        case 0x000D00D2: return "Issue Order: unimmolation";
        case 0x000D00D3: return "Issue Order: manaburn";
        case 0x000D00D4: return "Issue Order: metamorphosis";
        case 0x000D00D5: return "Issue Order: scout";
        case 0x000D00D6: return "Issue Order: sentinel";
        case 0x000D00D7: return "Issue Order: starfall";
        case 0x000D00D8: return "Issue Order: tranquility";
        case 0x000D00D9: return "Issue Order: acolyteharvest";
        case 0x000D00DA: return "Issue Order: antimagicshell";
        case 0x000D00DB: return "Issue Order: blight";
        case 0x000D00DC: return "Issue Order: cannibalize";
        case 0x000D00DD: return "Issue Order: cripple";
        case 0x000D00DE: return "Issue Order: curse";
        case 0x000D00DF: return "Issue Order: curseon";
        case 0x000D00E0: return "Issue Order: curseoff";
        case 0x000D00E3: return "Issue Order: freezingbreath";
        case 0x000D00E4: return "Issue Order: possession";
        case 0x000D00E5: return "Issue Order: raisedead";
        case 0x000D00E6: return "Issue Order: raisedeadon";
        case 0x000D00E7: return "Issue Order: raisedeadoff";
        case 0x000D00E8: return "Issue Order: instant";
        case 0x000D00E9: return "Issue Order: requestsacrifice";
        case 0x000D00EA: return "Issue Order: restoration";
        case 0x000D00EB: return "Issue Order: restorationon";
        case 0x000D00EC: return "Issue Order: restorationoff";
        case 0x000D00ED: return "Issue Order: sacrifice";
        case 0x000D00EE: return "Issue Order: stoneform";
        case 0x000D00EF: return "Issue Order: unstoneform";
        case 0x000D00F1: return "Issue Order: unholyfrenzy";
        case 0x000D00F2: return "Issue Order: unsummon";
        case 0x000D00F3: return "Issue Order: web";
        case 0x000D00F4: return "Issue Order: webon";
        case 0x000D00F5: return "Issue Order: weboff";
        case 0x000D00F6: return "Issue Order: wispharvest";
        case 0x000D00F7: return "Issue Order: auraunholy";
        case 0x000D00F8: return "Issue Order: auravampiric";
        case 0x000D00F9: return "Issue Order: animatedead";
        case 0x000D00FA: return "Issue Order: carrionswarm";
        case 0x000D00FB: return "Issue Order: darkritual";
        case 0x000D00FC: return "Issue Order: darksummoning";
        case 0x000D00FD: return "Issue Order: deathanddecay";
        case 0x000D00FE: return "Issue Order: deathcoil";
        case 0x000D00FF: return "Issue Order: deathpact";
        case 0x000D0100: return "Issue Order: dreadlordinferno";
        case 0x000D0101: return "Issue Order: frostarmor";
        case 0x000D0102: return "Issue Order: frostnova";
        case 0x000D0103: return "Issue Order: sleep";
        case 0x000D0104: return "Issue Order: darkconversion";
        case 0x000D0105: return "Issue Order: darkportal";
        case 0x000D0106: return "Issue Order: fingerofdeath";
        case 0x000D0107: return "Issue Order: firebold";
        case 0x000D0108: return "Issue Order: inferno";
        case 0x000D0109: return "Issue Order: gold2lumber";
        case 0x000D010A: return "Issue Order: lumber2gold";
        case 0x000D010B: return "Issue Order: spies";
        case 0x000D010D: return "Issue Order: rainofchaos";
        case 0x000D010E: return "Issue Order: rainoffire";
        case 0x000D010F: return "Issue Order: request_hero";
        case 0x000D0110: return "Issue Order: disassociate";
        case 0x000D0111: return "Issue Order: revenge";
        case 0x000D0112: return "Issue Order: soulpreservation";
        case 0x000D0113: return "Issue Order: coldarrowstarg";
        case 0x000D0114: return "Issue Order: coldarrows";
        case 0x000D0115: return "Issue Order: uncoldarrows";
        case 0x000D0116: return "Issue Order: creepanimatedead";
        case 0x000D0117: return "Issue Order: creepdevour";
        case 0x000D0118: return "Issue Order: creepheal";
        case 0x000D0119: return "Issue Order: creephealon";
        case 0x000D011A: return "Issue Order: creephealoff";
        case 0x000D011C: return "Issue Order: creepthunderbold";
        case 0x000D011D: return "Issue Order: creepthunderclap";
        case 0x000D011E: return "Issue Order: poisonarrowstarg";
        case 0x000D011F: return "Issue Order: poisonarrows";
        case 0x000D0120: return "Issue Order: unpoisonarrows";
        case 0x000D01EA: return "Issue Order: frostarmoron";
        case 0x000D01EB: return "Issue Order: frostarmoroff";
        case 0x000D01EE: return "Issue Order: (reviveintavern1)";
        case 0x000D01EF: return "Issue Order: (reviveintavern2)";
        case 0x000D01F0: return "Issue Order: (reviveintavern3)";
        case 0x000D01F1: return "Issue Order: (reviveintavern4)";
        case 0x000D01F2: return "Issue Order: awaken";
        case 0x000D01F3: return "Issue Order: nagabuild";
        case 0x000D01F5: return "Issue Order: mount";
        case 0x000D01F6: return "Issue Order: dismount";
        case 0x000D01F9: return "Issue Order: cloudoffog";
        case 0x000D01FA: return "Issue Order: controlmagic";
        case 0x000D01FE: return "Issue Order: magicdefense";
        case 0x000D01FF: return "Issue Order: magiceundefense";
        case 0x000D0200: return "Issue Order: magicleash";
        case 0x000D0201: return "Issue Order: phoenixfire";
        case 0x000D0202: return "Issue Order: phoenixmorph";
        case 0x000D0203: return "Issue Order: spellsteal";
        case 0x000D0204: return "Issue Order: spellstealon";
        case 0x000D0205: return "Issue Order: spellstealoff";
        case 0x000D0206: return "Issue Order: banish";
        case 0x000D0207: return "Issue Order: drain";
        case 0x000D0208: return "Issue Order: flamestrike";
        case 0x000D0209: return "Issue Order: summonphoenix";
        case 0x000D020A: return "Issue Order: ancestralspirit";
        case 0x000D020B: return "Issue Order: ancestralspirittarget";
        case 0x000D020D: return "Issue Order: corporealform";
        case 0x000D020E: return "Issue Order: uncorporealform";
        case 0x000D020F: return "Issue Order: disenchant";
        case 0x000D0210: return "Issue Order: etherealform";
        case 0x000D0211: return "Issue Order: unetherealform";
        case 0x000D0213: return "Issue Order: spiritlink";
        case 0x000D0214: return "Issue Order: unstableconcoction";
        case 0x000D0215: return "Issue Order: healingwave";
        case 0x000D0216: return "Issue Order: hex";
        case 0x000D0217: return "Issue Order: voodo";
        case 0x000D0218: return "Issue Order: ward";
        case 0x000D0219: return "Issue Order: autoentangle";
        case 0x000D021A: return "Issue Order: autoentangleinstant";
        case 0x000D021B: return "Issue Order: coupletarget";
        case 0x000D021C: return "Issue Order: coupleinstant";
        case 0x000D021D: return "Issue Order: decouple";
        case 0x000D021F: return "Issue Order: grabtree";
        case 0x000D0220: return "Issue Order: manaflareon";
        case 0x000D0221: return "Issue Order: manaflareoff";
        case 0x000D0222: return "Issue Order: phaseshift";
        case 0x000D0223: return "Issue Order: phaseshifton";
        case 0x000D0224: return "Issue Order: phaseshiftoff";
        case 0x000D0225: return "Issue Order: phaseshiftinstant";
        case 0x000D0228: return "Issue Order: taunt";
        case 0x000D0229: return "Issue Order: vengeance";
        case 0x000D022A: return "Issue Order: vengeanceon";
        case 0x000D022B: return "Issue Order: vengeanceoff";
        case 0x000D022C: return "Issue Order: vengeanceinstant";
        case 0x000D022D: return "Issue Order: blink";
        case 0x000D022E: return "Issue Order: fanofknives";
        case 0x000D022F: return "Issue Order: shadowstrike";
        case 0x000D0230: return "Issue Order: spiritofvengeance";
        case 0x000D0231: return "Issue Order: absorb";
        case 0x000D0233: return "Issue Order: avengerform";
        case 0x000D0234: return "Issue Order: unavengerform";
        case 0x000D0235: return "Issue Order: burrow";
        case 0x000D0236: return "Issue Order: unburrow";
        case 0x000D0238: return "Issue Order: devourmagic";
        case 0x000D023B: return "Issue Order: flamingattacktarg";
        case 0x000D023C: return "Issue Order: flamingattack";
        case 0x000D023D: return "Issue Order: unflamingattack";
        case 0x000D023E: return "Issue Order: replenish";
        case 0x000D023F: return "Issue Order: replenishon";
        case 0x000D0240: return "Issue Order: replenishoff";
        case 0x000D0241: return "Issue Order: replenishlife";
        case 0x000D0242: return "Issue Order: replenishlifeon";
        case 0x000D0243: return "Issue Order: replenishlifeoff";
        case 0x000D0244: return "Issue Order: replenishmana";
        case 0x000D0245: return "Issue Order: replenishmanaon";
        case 0x000D0246: return "Issue Order: replenishmanaoff";
        case 0x000D0247: return "Issue Order: carrionscarabs";
        case 0x000D0248: return "Issue Order: carrionscarabson";
        case 0x000D0249: return "Issue Order: carrionscarabsoff";
        case 0x000D024A: return "Issue Order: carrionscarabsinstant";
        case 0x000D024B: return "Issue Order: impale";
        case 0x000D024C: return "Issue Order: locustswarm";
        case 0x000D0250: return "Issue Order: breathoffrost";
        case 0x000D0251: return "Issue Order: frenzy";
        case 0x000D0252: return "Issue Order: frenzyon";
        case 0x000D0253: return "Issue Order: frenzyoff";
        case 0x000D0254: return "Issue Order: mechanicalcritter";
        case 0x000D0255: return "Issue Order: mindrot";
        case 0x000D0256: return "Issue Order: neutralinteract";
        case 0x000D0258: return "Issue Order: preservation";
        case 0x000D0259: return "Issue Order: sanctuary";
        case 0x000D025A: return "Issue Order: shadowsight";
        case 0x000D025B: return "Issue Order: spellshield";
        case 0x000D025C: return "Issue Order: spellshieldaoe";
        case 0x000D025D: return "Issue Order: spirittroll";
        case 0x000D025E: return "Issue Order: steal";
        case 0x000D0260: return "Issue Order: attributemodskill";
        case 0x000D0261: return "Issue Order: blackarrow";
        case 0x000D0262: return "Issue Order: blackarrowon";
        case 0x000D0263: return "Issue Order: blackarrowoff";
        case 0x000D0264: return "Issue Order: breahoffire";
        case 0x000D0265: return "Issue Order: charm";
        case 0x000D0267: return "Issue Order: doom";
        case 0x000D0269: return "Issue Order: drunkenhaze";
        case 0x000D026A: return "Issue Order: elementalfury";
        case 0x000D026B: return "Issue Order: forkedlightning";
        case 0x000D026C: return "Issue Order: howlofterror";
        case 0x000D026D: return "Issue Order: manashieldon";
        case 0x000D026E: return "Issue Order: manashieldoff";
        case 0x000D026F: return "Issue Order: monsoon";
        case 0x000D0270: return "Issue Order: silence";
        case 0x000D0271: return "Issue Order: stampede";
        case 0x000D0272: return "Issue Order: summongrizzly";
        case 0x000D0273: return "Issue Order: summonquillbeast";
        case 0x000D0274: return "Issue Order: summonwareagle";
        case 0x000D0275: return "Issue Order: tornado";
        case 0x000D0276: return "Issue Order: wateryminion";
        case 0x000D0277: return "Issue Order: battleroar";
        case 0x000D0278: return "Issue Order: channel";
        case 0x000D0279: return "Issue Order: parasite";
        case 0x000D027A: return "Issue Order: parasiteon";
        case 0x000D027B: return "Issue Order: parasiteoff";
        case 0x000D027C: return "Issue Order: submerge";
        case 0x000D027D: return "Issue Order: unsubmerge";
        case 0x000D0296: return "Issue Order: neutralspell";
        case 0x000D02AB: return "Issue Order: militiaunconvert";
        case 0x000D02AC: return "Issue Order: clusterrockets";
        case 0x000D02B0: return "Issue Order: robogoblin";
        case 0x000D02B1: return "Issue Order: unrobogoblin";
        case 0x000D02B2: return "Issue Order: summonfactory";
        case 0x6861726F: return "Build Arcane Observatory";
        case 0x68686573: return "Train Swordsman";
        case 0x6F636277: return "Build Fel Orc Burrow";
        case 0x4F647274: return "Summon Far Seer";
        case 0x4F726B6E: return "Summon Shadow Hunter";
        case 0x4F676C64: return "Summon Warlock";
        case 0x4F726578: return "Summon Beastmaster";
        case 0x6E706E34: return "Summon Fire";
        case 0x6E706E35: return "Summon Storm";
        case 0x6E706E36: return "Summon Earth";
        case 0x6F6A676E: return "Train Orc Juggernaught";
        case 0x5573796C: return "Summon Dark Ranger";
        case 0x75617262: return "Summon Sky Barge";
        case 0x75736870: return "Shipyard";
        case 0x6E636B62: return "Train Fel Orc Kodo Beast";
        case 0x6E636867: return "Train Fel Orc Grunt";
        case 0x6E636872: return "Train Fel Orc Raider";
        case 0x6E636877: return "Train Fel Orc Warlock";
        case 0x6E63706E: return "Train Fel Orc Peon";
        case 0x6E686561: return "Train Archer";
        case 0x6E706766: return "Build Pig Farm";
        case 0x6E636170: return "Create Corrupted Ancient Protector";
        case 0x6E636D77: return "Create Corrupted Moon Well";
        case 0x6E63746C: return "Create Corrupted Tree of Life";
        case 0x6E637461: return "Upgrade to Corrupted Tree of Ages";
        case 0x6E637465: return "Upgrade to Corrupted Tree of Eternity";
        case 0x6E636177: return "Create Corrupted Ancient of War";
        case 0x6E647262: return "Build Dragon Roost";
        case 0x75616263: return "Train Abomination";
        case 0x7A6D6172: return "Train Marine";
        case 0x7A6A7567: return "Train Orc Juggernaught";
        case 0x7A7A7267: return "Train Zergling";
        case 0x7A687964: return "Train Hydralisk";
        case 0x7A63736F: return "Train Space Fel Orc";
        case 0x7A736D63: return "Train Sammy";
        case 0x7A736876: return "Train Kobold Shoveler";
        case 0x6E6D7065: return "Train Mur'gul Slave";
        case 0x6E6E666D: return "Build Coral Bed";
        case 0x6E6E7467: return "Build Tidal Guardian";
        case 0x6E6E7474: return "Build Temple of Tides";
        case 0x6E6E7367: return "Build Spawning Grounds";
        case 0x6E6E7361: return "Build Shrine of Azshara";
        case 0x6E6E6164: return "Build Altar of the Depths";
        case 0x6E6E6D67: return "Train Mur'gul Reaver";
        case 0x6E6D7972: return "Train Naga Myrmidon";
        case 0x6E6D7973: return "Train Naga Myrmidon";
        case 0x6E6E7267: return "Train Naga Royal Guard";
        case 0x6E6E7273: return "Train Naga Royal Guard";
        case 0x6E6E7377: return "Train Naga Siren";
        case 0x6E6E7375: return "Train Summoner";
        case 0x6E736E70: return "Train Snap Dragon";
        case 0x6E736273: return "Train Snap Dragon";
        case 0x6E776773: return "Train Couatl";
        case 0x6E687963: return "Train Dragon Turtle";
        case 0x6E62656C: return "Train Blood Elf Lieutenant";
        case 0x6E626565: return "Train Blood Elf Engineer";
        case 0x6E64726C: return "Train Drainei Laborer";
        case 0x6E646834: return "Build Seer's Den";
        case 0x6E646833: return "Build Draenei Barracks";
        case 0x6E646832: return "Build Draenei Haven";
        case 0x6E647361: return "Train Salamander";
        case 0x6E636174: return "Train Draenei Demolisher";
        case 0x4E736A73: return "Summon Pandaren Brewmaster";
        case 0x6E686577: return "Train Worker";
        case 0x6E657431: return "Build Energy Tower";
        case 0x6E657432: return "Upgrade to Advanced Energy Tower";
        case 0x6E627431: return "Build Boulder Tower";
        case 0x6E627432: return "Upgrade to Advanced Boulder Tower";
        case 0x6E667431: return "Build Flame Tower";
        case 0x6E667432: return "Upgrade to Advanced Flame Tower";
        case 0x6E647431: return "Build Cold Tower";
        case 0x6E647432: return "Upgrade to Advanced Cold Tower";
        case 0x6E747431: return "Build Death Tower";
        case 0x6E747832: return "Upgrade to Advanced Death Tower";
        case 0x6E667274: return "Build Fruit Stand";
        case 0x68707274: return "Open Portal";
        case 0x6E7A6C63: return "Lich King";
        case 0x6E636870: return "Train Chaplain";
        case 0x6E68796D: return "Train Hydromancer";
        case 0x6E7A696E: return "Zone Indicator";
        case 0x6E627365: return "Create Resurrection Stone";
        case 0x6E627377: return "Create Resurrection Stone";
        case 0x41616D6B: return "Attribute Bonus";
        case 0x4143746E: return "Spawn Tentacle";
        case 0x41437337: return "Feral Spirit";
        case 0x414E6176: return "Avatar";
        case 0x414E7368: return "Shockwave";
        case 0x41437338: return "Spirit Beast";
        case 0x414E7232: return "Reincarnation";
        case 0x41666262: return "Feedback";
        case 0x416E646D: return "Abolish Magic";
        case 0x41736231: return "Submerge";
        case 0x41736232: return "Submerge";
        case 0x41736233: return "Submerge";
        case 0x414E6861: return "Harvest";
        case 0x414E656E: return "Ensnare";
        case 0x41436675: return "Frost Armor";
        case 0x414E7061: return "Parasite";
        case 0x41636E79: return "Cyclone";
        case 0x41686E6C: return "Summoning Ritual";
        case 0x414E636C: return "Channel";
        case 0x41727371: return "Summon Quilbeast";
        case 0x41727367: return "Summon Misha";
        case 0x41727370: return "Stampede";
        case 0x414E6272: return "Battle Roar";
        case 0x414E7362: return "Storm Bolt";
        case 0x414E6366: return "Breath of Fire";
        case 0x41636462: return "Drunken Brawler";
        case 0x41636468: return "Drunken Haze";
        case 0x41636566: return "Storm, Earth, And Fire";
        case 0x414E6877: return "Healing Wave";
        case 0x414E6878: return "Hex";
        case 0x41727377: return "Serpent Ward";
        case 0x414F7232: return "Endurance Aura";
        case 0x414F7332: return "Shockwave";
        case 0x414F7233: return "Reincarnation";
        case 0x414F7732: return "War Stomp";
        case 0x414F6C73: return "Voodoo Spirits";
        case 0x526E7377: return "Research Naga Siren Adept Training/Research Naga Siren Master Training";
        case 0x526E656E: return "Research Ensnare";
        case 0x526E7369: return "Research Abolish Magic";
        case 0x526E616D: return "Upgrade to Coral Scales/Upgrade to Chitinous Scales/Upgrade to Razorspine Scales";
        case 0x526E6174: return "Upgrade to Coral Blades/Upgrade to Chitinous Blades/Upgrade to Razorspine Blades";
        case 0x526E7362: return "Research Submerge";
        case 0x48626C6D: return "Summon Blood Mage";
        case 0x68616C74: return "Build Altar of Kings";
        case 0x48616D67: return "Summon Archmage";
        case 0x6861726D: return "Build Workshop";
        case 0x68617273: return "Build Arcane Sanctum";
        case 0x68626172: return "Build Barracks";
        case 0x68626C61: return "Build Blacksmith";
        case 0x68636173: return "Upgrade to Castle";
        case 0x68646877: return "Train Dragonhawk Rider";
        case 0x68686F75: return "Build Farm";
        case 0x68666F6F: return "Train Footman";
        case 0x68677261: return "Build Gryphon Aviary";
        case 0x68637477: return "Upgrade to Cannon Tower";
        case 0x68677477: return "Upgrade to Guard Tower";
        case 0x68777477: return "Build Scout Tower";
        case 0x68617477: return "Upgrade to Arcane Tower";
        case 0x68766C74: return "Build Arcane Vault";
        case 0x68677972: return "Train Flying Machine";
        case 0x686B6565: return "Upgrade to Keep";
        case 0x686B6E69: return "Train Knight";
        case 0x686C756D: return "Build Lumber Mill";
        case 0x486D6B67: return "Summon Mountain King";
        case 0x686D7072: return "Train Priest";
        case 0x686D746D: return "Train Mortar Team";
        case 0x4870616C: return "Summon Paladin";
        case 0x68706561: return "Train Peasant";
        case 0x68726966: return "Train Rifleman";
        case 0x68736F72: return "Train Sorceress";
        case 0x68737074: return "Train Spell Breaker";
        case 0x686D7474: return "Train Siege Engine";
        case 0x68727474: return "Train Siege Engine";
        case 0x68746F77: return "Build Town Hall";
        case 0x68677279: return "Train Gryphon Rider";
        case 0x68736879: return "Build Human Shipyard";
        case 0x68627368: return "Hire Battleship";
        case 0x68646573: return "Hire Frigate";
        case 0x68626F74: return "Hire Transport Ship";
        case 0x6F616C74: return "Build Altar of Storms";
        case 0x6F626172: return "Build Barracks";
        case 0x6F626561: return "Build Beastiary";
        case 0x4F626C61: return "Summon Blademaster";
        case 0x6F636174: return "Train Demolisher";
        case 0x6F646F63: return "Train Troll Witch Doctor";
        case 0x4F666172: return "Summon Far Seer";
        case 0x6F666F72: return "Build War Mill";
        case 0x6F667274: return "Upgrade to Fortress";
        case 0x6F677265: return "Build Great Hall";
        case 0x6F677275: return "Train Grunt";
        case 0x6F68756E: return "Train Troll Headhunter";
        case 0x6F74626B: return "Train Troll Berserker";
        case 0x6F6B6F64: return "Train Kodo Beast";
        case 0x6F736C64: return "Build Spirit Lodge";
        case 0x6F70656F: return "Train Peon";
        case 0x6F726169: return "Train Raider";
        case 0x6F73686D: return "Train Shaman";
        case 0x6F737472: return "Upgrade to Stronghold";
        case 0x6F746175: return "Train Tauren";
        case 0x6F746272: return "Train Troll Batrider";
        case 0x4F736864: return "Summon Shadow Hunter";
        case 0x4F746368: return "Summon Tauren Chieftain";
        case 0x6F747262: return "Build Orc Burrow";
        case 0x6F726272: return "Build Reinforced Orc Burrow";
        case 0x6F74746F: return "Build Tauren Totem";
        case 0x6F766C6E: return "Build Voodoo Lounge";
        case 0x6F777976: return "Train Wind Rider";
        case 0x6F777477: return "Build Watch Tower";
        case 0x6F737077: return "Train Spirit Walker";
        case 0x6F73706D: return "Train Spirit Walker";
        case 0x6F736879: return "Build Orc Shipyard";
        case 0x6F626F74: return "Hire Transport Ship";
        case 0x6F646573: return "Hire Frigate";
        case 0x6562616C: return "Train Glaive Thrower";
        case 0x65747270: return "Create Ancient Protector";
        case 0x6563686D: return "Train Chimaera";
        case 0x65646F63: return "Train Druid of the Claw";
        case 0x6564636D: return "Train Druid of the Claw";
        case 0x65646F74: return "Train Druid of the Talon";
        case 0x6564746D: return "Train Druid of the Talon";
        case 0x65777370: return "Train Wisp";
        case 0x4564656D: return "Summon Demon Hunter";
        case 0x45646D6D: return "Summon Demon Hunter";
        case 0x456B6565: return "Summon Keeper of the Grove";
        case 0x456D6F6F: return "Summon Priestess of the Moon";
        case 0x45776172: return "Summon Warden";
        case 0x6573656E: return "Train Huntress";
        case 0x65617263: return "Train Archer";
        case 0x65647279: return "Train Dryad";
        case 0x65686970: return "Train Hippogryph";
        case 0x65687072: return "Ride Hippogryph";
        case 0x65746F6C: return "Create Tree of Life";
        case 0x65746F61: return "Upgrade to Tree of Ages";
        case 0x65746F65: return "Upgrade to Tree of Eternity";
        case 0x65646F62: return "Create Hunter's Hall";
        case 0x65617465: return "Create Altar of Elders";
        case 0x6564656E: return "Build Ancient of Wonders";
        case 0x65616F65: return "Create Ancient of Lore";
        case 0x65616F6D: return "Create Ancient of War";
        case 0x65616F77: return "Create Ancient of Wind";
        case 0x65646F73: return "Create Chimaera Roost";
        case 0x656D6F77: return "Create Moon Well";
        case 0x656D7467: return "Train Mountain Giant";
        case 0x65666472: return "Train Faerie Dragon";
        case 0x41696D70: return "Vorpal Blades";
        case 0x65747273: return "Hire Night Elf Transport Ship";
        case 0x65646573: return "Hire Frigate";
        case 0x65627368: return "Hire Battleship";
        case 0x65736879: return "Build Night Elf Shipyard";
        case 0x5563726C: return "Summon Crypt Lord";
        case 0x7561636F: return "Train Acolyte";
        case 0x7561626F: return "Train Abomination";
        case 0x55646561: return "Summon Death Knight";
        case 0x7562616E: return "Train Banshee";
        case 0x7563726D: return "Train Crypt Fiend";
        case 0x75637279: return "Train Crypt Fiend";
        case 0x55647265: return "Summon Dreadlord";
        case 0x7566726F: return "Train Frost Wyrm";
        case 0x75676172: return "Train Gargoyle";
        case 0x7567726D: return "Train Gargoyle";
        case 0x7567686F: return "Train Ghoul";
        case 0x556C6963: return "Summon Lich";
        case 0x756E6563: return "Train Necromancer";
        case 0x75736B65: return "Summon Skeleton Warrior";
        case 0x75736B6D: return "Summon Skeletal Mage";
        case 0x75616F64: return "Summon Altar of Darkness";
        case 0x756E706C: return "Summon Necropolis";
        case 0x756E7031: return "Upgrade to Halls of the Dead";
        case 0x756E7032: return "Upgrade to Black Citadel";
        case 0x75736570: return "Summon Crypt";
        case 0x75746F64: return "Summon Temple of the Damned";
        case 0x75746F6D: return "Summon Tomb of Relics";
        case 0x75676F6C: return "Haunt Gold Mine";
        case 0x757A6967: return "Summon Ziggurat";
        case 0x757A6731: return "Upgrade to Spirit Tower";
        case 0x757A6732: return "Upgrade to Nerubian Tower";
        case 0x756D7477: return "Train Meat Wagon";
        case 0x75626F6E: return "Summon Boneyard";
        case 0x75736170: return "Summon Sacrificial Pit";
        case 0x75736C68: return "Summon Slaughterhouse";
        case 0x75736864: return "Train Shade";
        case 0x75677276: return "Summon Graveyard";
        case 0x756F6273: return "Create Obsidian Statue";
        case 0x75627370: return "Morph into Destroyer";
        case 0x75626F74: return "Hire Transport Ship";
        case 0x75646573: return "Hire Frigate";
        case 0x75756273: return "Hire Battleship";
        case 0x6E736B61: return "Hire Skeleton Archer";
        case 0x6E736B65: return "Hire Skeleton Warrior";
        case 0x6E736B67: return "Hire Giant Skeleton Warrior";
        case 0x6E736B6D: return "Hire Skeletal Marksman";
        case 0x6E736B66: return "Hire Burning Archer";
        case 0x6E777331: return "Train Dragon Hawk";
        case 0x6E62616E: return "Hire Bandit";
        case 0x6E627267: return "Hire Brigand";
        case 0x6E726F67: return "Hire Rogue";
        case 0x6E656E66: return "Hire Enforcer";
        case 0x6E626C64: return "Hire Bandit Lord";
        case 0x6E617373: return "Hire Assassin";
        case 0x6E62646B: return "Summon Black Drake";
        case 0x6E72646B: return "Summon Red Dragon Whelp";
        case 0x6E626472: return "Summon Black Dragon Whelp";
        case 0x6E726472: return "Summon Red Drake";
        case 0x6E62776D: return "Summon Black Dragon";
        case 0x6E72776D: return "Summon Red Dragon";
        case 0x6E616472: return "Summon Blue Dragon";
        case 0x6E616477: return "Summon Blue Dragon Whelp";
        case 0x6E61646B: return "Summon Blue Drake";
        case 0x6E627A64: return "Summon Bronze Dragon";
        case 0x6E627A6B: return "Summon Bronze Drake";
        case 0x6E627A77: return "Summon Bronze Dragon Whelp";
        case 0x6E677264: return "Summon Green Dragon";
        case 0x6E67646B: return "Summon Green Drake";
        case 0x6E677277: return "Summon Green Dragon Whelp";
        case 0x6E647272: return "Build Red Dragon Roost";
        case 0x6E647267: return "Build Green Dragon Roost";
        case 0x6E64727A: return "Build Bronze Dragon Roost";
        case 0x6E64726B: return "Build Black Dragon Roost";
        case 0x6E647275: return "Build Blue Dragon Roost";
        case 0x6E636561: return "Hire Centaur Archer";
        case 0x6E63696D: return "Hire Centaur Impaler";
        case 0x6E63656E: return "Hire Centaur Outrunner";
        case 0x6E636572: return "Hire Centaur Drudge";
        case 0x6E636B73: return "Hire Centaur Sorcerer";
        case 0x6E636E6B: return "Hire Centaur Khan";
        case 0x6E647468: return "Hire Dark Troll High Priest";
        case 0x6E647470: return "Hire Dark Troll Shadow Priest";
        case 0x6E647462: return "Hire Dark Troll Berserker";
        case 0x6E647477: return "Hire Dark Troll Warlord";
        case 0x6E647472: return "Hire Dark Troll";
        case 0x6E647474: return "Hire Dark Troll Trapper";
        case 0x6E656C62: return "Summon Berserk Elemental";
        case 0x6E656C65: return "Summon Enraged Elemental";
        case 0x6E656E63: return "Summon Corrupted Treant";
        case 0x6E656E70: return "Summon Poison Treant";
        case 0x6E65706C: return "Summon Plague Treant";
        case 0x6E66656C: return "Summon Fel Stalker";
        case 0x6E667368: return "Hire Forest Troll High Priest";
        case 0x6E667370: return "Hire Forest Troll Shadow Priest";
        case 0x6E667472: return "Hire Forest Troll";
        case 0x6E667462: return "Hire Forest Troll Berserker";
        case 0x6E667474: return "Hire Forest Troll Trapper";
        case 0x6E66746B: return "Hire Forest Troll Warlord";
        case 0x6E676164: return "Build Goblin Laboratory";
        case 0x6E676D65: return "Build Goblin Merchant";
        case 0x6E736870: return "Build Goblin Shipyard";
        case 0x6E67726B: return "Summon Mud Golem";
        case 0x6E677374: return "Summon Rock Golem";
        case 0x6E676772: return "Summon Granite Golem";
        case 0x6E617267: return "Summon Battle Golem";
        case 0x6E777267: return "Summon War Golem";
        case 0x6E736767: return "Summon Siege Golem";
        case 0x6E676972: return "Hire Goblin Shredder";
        case 0x6E66726C: return "Hire Furbolg";
        case 0x6E667262: return "Hire Furbolg Tracker";
        case 0x6E667267: return "Hire Furbolg Champion";
        case 0x6E667261: return "Hire Furbolg Ursa Warrior";
        case 0x6E667273: return "Hire Furbolg Shaman";
        case 0x6E667265: return "Hire Furbolg Elder Shaman";
        case 0x6E676831: return "Summon Ghost";
        case 0x6E676832: return "Summon Wraith";
        case 0x6E676E61: return "Hire Gnoll Poarcher";
        case 0x6E676E73: return "Hire Gnoll Assassin";
        case 0x6E676E6F: return "Hire Gnoll Robber";
        case 0x6E676E62: return "Hire Gnoll Brute";
        case 0x6E676E77: return "Hire Gnoll Warden";
        case 0x6E676E76: return "Hire Gnoll Overseer";
        case 0x6E676F6C: return "Build Gold Mine";
        case 0x6E677370: return "Hire Goblin Sapper";
        case 0x6E686172: return "Hire Harpy Scout";
        case 0x6E687272: return "Hire Harpy Rogue";
        case 0x6E687277: return "Hire Harpy Windwitch";
        case 0x6E687268: return "Hire Harpy Storm-hag";
        case 0x6E687271: return "Hire Harpy Queen";
        case 0x6E686670: return "Hire Fallen Priest";
        case 0x6E686463: return "Hire Deceiver";
        case 0x6E686872: return "Hire Heretic";
        case 0x6E697472: return "Hire Ice Troll";
        case 0x6E697473: return "Hire Ice Troll Berserker";
        case 0x6E697474: return "Hire Ice Troll Trapper";
        case 0x6E697477: return "Hire Ice Troll Warlord";
        case 0x6E697468: return "Hire Ice Troll High Priest";
        case 0x6E697470: return "Hire Ice Troll Priest";
        case 0x6E6B6F62: return "Hire Kobold";
        case 0x6E6B6F67: return "Hire Kobold Geomancer";
        case 0x6E6B6F6C: return "Hire Kobold Taskmaster";
        case 0x6E6B6F74: return "Hire Kobold Tunneler";
        case 0x6E6C746C: return "Summon Lightning Lizard";
        case 0x6E6C7572: return "Create Monster Lure";
        case 0x6E74686C: return "Summon Thunder Lizard";
        case 0x6E737477: return "Summon Storm Wyrm";
        case 0x6E6D6673: return "Hire Murloc Flesheater";
        case 0x6E6D6D75: return "Hire Murloc Mutant";
        case 0x6E6D7067: return "Hire Murloc Plaguebearer";
        case 0x6E6D726C: return "Hire Murloc Tiderunner";
        case 0x6E6D7272: return "Hire Murloc Huntsman";
        case 0x6E6D726D: return "Hire Murloc Nightcrawler";
        case 0x6E6F7762: return "Summon Wildkin";
        case 0x6E6F7765: return "Summon Enraged Wildkin";
        case 0x6E6F776B: return "Summon Berserk Wildkin";
        case 0x6E727A73: return "Hire Razormane Scout";
        case 0x6E727A62: return "Hire Razormane Brute";
        case 0x6E727A6D: return "Hire Razormane Medicine Man";
        case 0x6E727A67: return "Hire Razormane Chieftain";
        case 0x6E727A74: return "Hire Quillboar";
        case 0x6E716268: return "Hire Quillboar Hunter";
        case 0x6E737064: return "Summon Spiderling";
        case 0x6E6E7761: return "Summon Nerubian Warrior";
        case 0x6E6E776C: return "Summon Nerubian Webspinner";
        case 0x6E6E7773: return "Summon Nerubian Spider Lord";
        case 0x6E6E7772: return "Summon Nerubian Seer";
        case 0x6E6E7771: return "Summon Nerubian Queen";
        case 0x6E6D6572: return "Build Mercenary Camp";
        case 0x6E6D7232: return "Build Mercenary Camp";
        case 0x6E6D7233: return "Build Mercenary Camp";
        case 0x6E6D7234: return "Build Mercenary Camp";
        case 0x6E6D7235: return "Build Mercenary Camp";
        case 0x6E6D7236: return "Build Mercenary Camp";
        case 0x6E6D7237: return "Build Mercenary Camp";
        case 0x6E6D7238: return "Build Mercenary Camp";
        case 0x6E6D7239: return "Build Mercenary Camp";
        case 0x6E6D7230: return "Build Mercenary Camp";
        case 0x6E6D7261: return "Build Mercenary Camp";
        case 0x6E6D7262: return "Build Mercenary Camp";
        case 0x6E6D7263: return "Build Mercenary Camp";
        case 0x6E746176: return "Build Tavern";
        case 0x6E6D6F6F: return "Build Fountain of Mana";
        case 0x6E666F68: return "Build Fountain of Health";
        case 0x6E6D726B: return "Build Marketplace";
        case 0x6E6F6772: return "Hire Ogre Warrior";
        case 0x6E6F676D: return "Hire Ogre Mauler";
        case 0x6E6F676C: return "Hire Ogre Lord";
        case 0x6E6F6D67: return "Hire Ogre Magi";
        case 0x6E727666: return "Summon Fire Revenant";
        case 0x6E727673: return "Summon Frost Revenant";
        case 0x6E72766C: return "Summon Lightning Revenant";
        case 0x6E727669: return "Summon Ice Revenant";
        case 0x6E727664: return "Summon Death Revenant";
        case 0x6E736C6D: return "Summon Sludge Minion";
        case 0x6E736C66: return "Summon Sludge Flinger";
        case 0x6E736C6E: return "Summon Sludge Monstrosity";
        case 0x6E736C68: return "Summon Salamander Hatchling";
        case 0x6E736C72: return "Summon Salamander";
        case 0x6E736C76: return "Summon Salamander Vizier";
        case 0x6E736C6C: return "Summon Salamander Lord";
        case 0x6E736174: return "Hire Satyr Trickster";
        case 0x6E737473: return "Hire Satyr Shadowdancer";
        case 0x6E737468: return "Hire Satyr Hellcaller";
        case 0x6E73746C: return "Hire Satyr Soulstealer";
        case 0x6E737479: return "Hire Satyr";
        case 0x6E737062: return "Summon Black Spider";
        case 0x6E737072: return "Summon Spider";
        case 0x6E736774: return "Summon Giant Spider";
        case 0x6E737370: return "Summon Spitting Spider";
        case 0x6E73626D: return "Summon Brood Mother";
        case 0x6E737067: return "Summon Forest Spider";
        case 0x6E737174: return "Summon Sasquatch";
        case 0x6E737165: return "Summon Elder Sasquatch";
        case 0x6E73716F: return "Summon Sasquatch Oracle";
        case 0x6E737161: return "Summon Ancient Sasquatch";
        case 0x6E646F67: return "Invoke Dog";
        case 0x6E706967: return "Invoke Pig";
        case 0x6E646572: return "Invoke Stag";
        case 0x6E736561: return "Invoke Seal";
        case 0x6E736865: return "Invoke Sheep";
        case 0x6E736861: return "Invoke Sheep";
        case 0x6E736877: return "Invoke Sheep";
        case 0x6E736866: return "Invoke Uber Sheep";
        case 0x6E76696C: return "Hire Villager";
        case 0x6E766C6B: return "Hire Villager";
        case 0x6E766C77: return "Hire Villager";
        case 0x6E76756C: return "Invoke Vulture";
        case 0x6E77656E: return "Summon Wendigo";
        case 0x6E776C74: return "Summon Timber Wolf";
        case 0x6E776C67: return "Summon Giant Wolf";
        case 0x6E776C64: return "Summon Dire Wolf";
        case 0x6E777766: return "Summon Frost Wolf";
        case 0x6E777767: return "Summon Giant Frost Wolf";
        case 0x6E777764: return "Summon Dire Frost Wolf";
        case 0x6E776E72: return "Summon Elder Wendigo";
        case 0x6E776E61: return "Summon Ancient Wendigo";
        case 0x6E776E73: return "Summon Wendigo Shaman";
        case 0x6E777A72: return "Hire Rogue Wizard";
        case 0x6E777A67: return "Hire Renegade Wizard";
        case 0x6E77697A: return "Hire Apprentice Wizard";
        case 0x6E777A64: return "Hire Dark Wizard";
        case 0x6E7A6570: return "Hire Goblin Zeppelin";
        case 0x6E696E66: return "Summon Infernal";
        case 0x6E62616C: return "Summon Doom Guard";
        case 0x6E776774: return "Build Way Gate";
        case 0x6E636E74: return "Build Centaur Tent";
        case 0x6E637431: return "Build Centaur Tent";
        case 0x6E637432: return "Build Centaur Tent";
        case 0x6E746E74: return "Build Tauren Tent";
        case 0x6E747432: return "Build Tauren Tent";
        case 0x6E676E68: return "Build Gnoll Hut";
        case 0x6E677432: return "Build Gnoll Hut";
        case 0x6E74656E: return "Build Tent";
        case 0x6E746E32: return "Build Tent";
        case 0x6E666830: return "Build Forest Troll Hut";
        case 0x6E666831: return "Build Forest Troll Hut";
        case 0x6E667231: return "Build Furbolg Hut";
        case 0x6E667232: return "Build Furbolg Hut";
        case 0x6E746830: return "Build Ice Troll Hut";
        case 0x6E746831: return "Build Ice Troll Hut";
        case 0x6E636230: return "Build City Building";
        case 0x6E636231: return "Build City Building";
        case 0x6E636232: return "Build City Building";
        case 0x6E636233: return "Build City Building";
        case 0x6E636234: return "Build City Building";
        case 0x6E636235: return "Build City Building";
        case 0x6E636236: return "Build City Building";
        case 0x6E636237: return "Build City Building";
        case 0x6E636238: return "Build City Building";
        case 0x6E636239: return "Build City Building";
        case 0x6E636261: return "Build City Building";
        case 0x6E636262: return "Build City Building";
        case 0x6E636263: return "Build City Building";
        case 0x6E636264: return "Build City Building";
        case 0x6E636265: return "Build City Building";
        case 0x6E636266: return "Build City Building";
        case 0x6E6D6830: return "Build Murloc Hut";
        case 0x6E6D6831: return "Build Murloc Hut";
        case 0x6E6E7A67: return "Build Nerubian Ziggurat";
        case 0x6E636F70: return "Build Circle of Power";
        case 0x6E637032: return "Build Circle of Power";
        case 0x6E637033: return "Build Circle of Power";
        case 0x6E686E73: return "Build Harpy Nest";
        case 0x4E70626D: return "Summon Pandaren Brewmaster";
        case 0x6E706E31: return "Summon Fire";
        case 0x6E706E32: return "Summon Storm";
        case 0x6E706E33: return "Summon Earth";
        case 0x4E62726E: return "Summon Dark Ranger";
        case 0x6E647231: return "Summon Dark Minion";
        case 0x6E647232: return "Summon Dark Minion";
        case 0x6E647233: return "Summon Dark Minion";
        case 0x6E736B6B: return "Invoke Skink";
        case 0x6E637262: return "Invoke Crab";
        case 0x6E686D63: return "Invoke Hermit Crab";
        case 0x6E616C62: return "Invoke Albatross";
        case 0x6E747268: return "Hire Sea Turtle Hatchling";
        case 0x6E747273: return "Hire Sea Turtle";
        case 0x6E747274: return "Hire Giant Sea Turtle";
        case 0x6E747267: return "Hire Gargantuan Sea Turtle";
        case 0x6E747264: return "Hire Dragon Turtle";
        case 0x6E687964: return "Hire Hydra";
        case 0x6E687968: return "Hire Hydra Hatchling";
        case 0x6E656879: return "Hire Elder Hydra";
        case 0x6E616879: return "Hire Ancient Hydra";
        case 0x6E6C7072: return "Hire Makrura Prawn";
        case 0x6E6C7073: return "Summoned Prawn";
        case 0x6E6C7463: return "Hire Makrura Tidecaller";
        case 0x6E6C7064: return "Hire Makrura Pooldweller";
        case 0x6E6C6473: return "Hire Makrura Deepseer";
        case 0x6E6C736E: return "Hire Makrura Snapper";
        case 0x6E6C6B6C: return "Hire Makrura Tidal Lord";
        case 0x6E6D6366: return "Hire Mur'gul Cliffrunner";
        case 0x6E6D6267: return "Hire Mur'gul Blood-Gill";
        case 0x6E6D7477: return "Hire Mur'gul Tidewarrior";
        case 0x6E6D736E: return "Hire Mur'gul Snarecaster";
        case 0x6E6D7276: return "Hire Mur'gul Marauder";
        case 0x6E6D7363: return "Hire Mur'gul Shadowcaster";
        case 0x6E736362: return "Hire Spider Crab Shorecrawler";
        case 0x6E747276: return "Hire Revenant of the Tides";
        case 0x6E737276: return "Hire Revenant of the Seas";
        case 0x6E647276: return "Hire Revenant of the Depths";
        case 0x6E6C7276: return "Hire Deeplord Revenant";
        case 0x6E72656C: return "Summon Reef Elemental";
        case 0x6E73656C: return "Summon Sea Elemental";
        case 0x6E73676E: return "Summon Sea Giant";
        case 0x6E736768: return "Summon Sea Giant Hunter";
        case 0x6E736762: return "Summon Sea Giant Behemoth";
        case 0x6E736B6F: return "Summon Skeletal Orc";
        case 0x6E736F67: return "Summon Skeletal Orc Grunt";
        case 0x6E736F63: return "Summon Skeletal Orc Champion";
        case 0x6E737261: return "Hire Stormreaver Apprentice";
        case 0x6E737268: return "Hire Stormreaver Hermit";
        case 0x6E73726E: return "Hire Stormreaver Necrolyte";
        case 0x6E737277: return "Hire Stormreaver Warlock";
        case 0x6E626F74: return "Hire Transport Ship";
        case 0x6E667270: return "Hire Pandaren";
        case 0x4E6E6773: return "Summon Naga Sea Witch";
        case 0x4E706C68: return "Summon Pit Lord";
        case 0x4E627374: return "Summon Beastmaster";
        case 0x6E736332: return "Hire Spider Crab";
        case 0x6E736333: return "Hire Spider Crab";
        case 0x6E6D616D: return "Hire Mammoth";
        case 0x6E6D6974: return "Hire Icetusk Mammoth";
        case 0x6E6D6472: return "Hire Dire Mammoth";
        case 0x6E66676F: return "Hire Forgotten One";
        case 0x6E746B66: return "Hire Tuskarr Fighter";
        case 0x6E746B61: return "Hire Tuskarr Spearman";
        case 0x6E746B77: return "Hire Tuskarr Warrior";
        case 0x6E746B74: return "Hire Tuskarr Trapper";
        case 0x6E746B63: return "Hire Tuskarr Chieftain";
        case 0x6E746B68: return "Hire Tuskarr Healer";
        case 0x6E746B73: return "Hire Tuskarr Sorcerer";
        case 0x6E62646D: return "Hire Blue Dragonspawn Meddler";
        case 0x6E626477: return "Hire Blue Dragonspawn Warrior";
        case 0x6E62646F: return "Hire Blue Dragonspawn Overseer";
        case 0x6E626461: return "Hire Blue Dragonspawn Apprentice";
        case 0x6E626473: return "Hire Blue Dragonspawn Sorcerer";
        case 0x6E6D6777: return "Hire Magnataur Warrior";
        case 0x6E6D6772: return "Hire Magnataur Reaver";
        case 0x6E6D6764: return "Hire Magnataur Destroyer";
        case 0x6E616E63: return "Hire Crystal Arachnathid";
        case 0x6E616E62: return "Hire Barbed Arachnathid";
        case 0x6E616E6D: return "Hire Barbed Arachnathid";
        case 0x6E626E62: return "Hire Barbed Arachnathid";
        case 0x6E616E77: return "Hire Warrior Arachnathid";
        case 0x6E616E65: return "Hire Arachnathid Earth-borer ";
        case 0x6E616E6F: return "Hire Overlord Arachnathid";
        case 0x6E666F72: return "Hire Faceless One Trickster";
        case 0x6E666F74: return "Hire Faceless One Terror";
        case 0x6E666F64: return "Hire Faceless One Deathbringer";
        case 0x6E75626B: return "Hire Unbroken Darkhunter";
        case 0x6E756272: return "Hire Unbroken Rager";
        case 0x6E756277: return "Hire Unbroken Darkweaver";
        case 0x6E706C62: return "Hire Polar Bear";
        case 0x6E706C67: return "Hire Giant Polar Bear";
        case 0x6E636673: return "Summon Watery Minion";
        case 0x6E747773: return "Summon Watery Minion";
        case 0x6E736E73: return "Summon Watery Minion";
        case 0x6E676E69: return "Build Infected Granary";
        case 0x6E677772: return "Build Grain Warehouse";
        case 0x6E66706C: return "Hire Polar Furbolg";
        case 0x6E667063: return "Hire Polar Furbolg Champion";
        case 0x6E667065: return "Hire Polar Furbolg Elder Shaman";
        case 0x6E667073: return "Hire Polar Furbolg Shaman";
        case 0x6E667075: return "Hire Polar Furbolg Ursa Warrior";
        case 0x6E667074: return "Hire Polar Furbolg Tracker";
        case 0x6E6D6776: return "Build Magic Vault";
        case 0x6E697462: return "Build Treasure Box";
        case 0x6E6D7264: return "Build Mercenary Camp";
        case 0x6E6D7265: return "Build Mercenary Camp";
        case 0x6E6D7266: return "Build Mercenary Camp";
        case 0x6E64726F: return "Build Nether Dragon Roost";
        case 0x6E706E67: return "Invoke Penguin";
        case 0x6E706E77: return "Invoke Penguin";
        case 0x6E726174: return "Invoke Rat";
        case 0x6E736E6F: return "Invoke Snowy Owl";
        case 0x6E666272: return "Invoke Fel Boar";
        case 0x6E64776D: return "Invoke Dune Worm";
        case 0x6E766B32: return "Hire Villager";
        case 0x6E766C32: return "Hire Villager";
        case 0x6E776331: return "Build Wyvern Cage";
        case 0x6E776332: return "Build Wyvern Cage";
        case 0x6E7A6F6D: return "Summon Zombie";
        case 0x6E70666C: return "Summon Fel Beast";
        case 0x6E70666D: return "Summon Fel Ravager";
        case 0x6E64716E: return "Hire Succubus";
        case 0x6E647176: return "Hire Vile Tormentor";
        case 0x6E647174: return "Hire Vile Temptress";
        case 0x6E647170: return "Hire Maiden of Pain";
        case 0x6E647173: return "Hire Queen of Suffering";
        case 0x6E6D6730: return "Build Mur'gul Hut";
        case 0x6E6D6731: return "Build Mur'gul Hut";
        case 0x6E666775: return "Hire Felguard";
        case 0x6E666762: return "Hire Bloodfiend";
        case 0x6E666F76: return "Hire Overlord";
        case 0x6E647266: return "Hire Draenei Guardian";
        case 0x6E647274: return "Hire Draenei Stalker";
        case 0x6E64726E: return "Hire Draenei Vindicator";
        case 0x6E647270: return "Hire Draenei Protector";
        case 0x6E647277: return "Hire Draenei Watcher";
        case 0x6E647264: return "Hire Draenei Darkslayer";
        case 0x6E64726D: return "Hire Draenei Disciple";
        case 0x6E647268: return "Hire Draenei Harbinger";
        case 0x6E647273: return "Hire Draenei Seer";
        case 0x6E696E63: return "Hire Infernal Contraption";
        case 0x6E696E6D: return "Hire Infernal Machine";
        case 0x6E696E61: return "Hire Infernal Juggernaut";
        case 0x6E76646C: return "Hire Lesser Voidwalker";
        case 0x6E766477: return "Hire Voidwalker";
        case 0x6E766467: return "Hire Greater Voidwalker";
        case 0x6E766465: return "Hire Elder Voidwalker";
        case 0x6E6E6874: return "Summon Nether Dragon Hatchling";
        case 0x6E6E646B: return "Summon Nether Drake";
        case 0x6E6E6472: return "Summon Nether Dragon";
        case 0x6E657273: return "Hire Eredar Sorcerer";
        case 0x6E657264: return "Hire Eredar Diabolist";
        case 0x6E657277: return "Hire Eredar Warlock";
        case 0x6E6F676F: return "Hire Stonemaul Ogre";
        case 0x6E6F676E: return "Hire Stonemaul Magi";
        case 0x6E6F6761: return "Hire Stonemaul Warchief";
        case 0x6E646830: return "Build Draenei Hut";
        case 0x6E646831: return "Build Draenei Hut";
        case 0x6E646368: return "Build Draenei Chieftain's Hut";
        case 0x6E6A6762: return "Summon Enraged Jungle Stalker";
        case 0x6E6A6761: return "Summon Elder Jungle Stalker";
        case 0x6E6A6731: return "Summon Jungle Stalker";
        case 0x416D6C73: return "Aerial Shackles";
        case 0x41487461: return "Reveal";
        case 0x4166626B: return "Feedback";
        case 0x41666274: return "Feedback";
        case 0x41636D67: return "Control Magic";
        case 0x41486472: return "Siphon Mana";
        case 0x41666C6B: return "Flak Cannons";
        case 0x41667368: return "Fragmentation Shards";
        case 0x41726F63: return "Barrage";
        case 0x416D6466: return "Magic Defense";
        case 0x41737068: return "Sphere";
        case 0x41737073: return "Spell Steal";
        case 0x41636C66: return "Cloud";
        case 0x41486673: return "Flame Strike";
        case 0x4148626E: return "Banish";
        case 0x41487078: return "Phoenix";
        case 0x41706878: return "Phoenix Morphing ";
        case 0x41707866: return "Phoenix Fire";
        case 0x41677962: return "Flying Machine Bombs";
        case 0x41737468: return "Storm Hammers";
        case 0x41677976: return "True Sight";
        case 0x41646566: return "Defend";
        case 0x41666C61: return "Flare";
        case 0x41647473: return "Magic Sentry";
        case 0x41696E66: return "Inner Fire";
        case 0x41646973: return "Dispel Magic";
        case 0x41686561: return "Heal";
        case 0x41736C6F: return "Slow";
        case 0x41697673: return "Invisibility";
        case 0x41706C79: return "Polymorph";
        case 0x4148627A: return "Blizzard";
        case 0x41487765: return "Summon Water Elemental";
        case 0x41486162: return "Brilliance Aura";
        case 0x41486D74: return "Mass Teleport";
        case 0x41487462: return "Storm Bolt";
        case 0x41487463: return "Thunder Clap";
        case 0x41486268: return "Bash";
        case 0x41486176: return "Avatar";
        case 0x41486862: return "Holy Light";
        case 0x41486473: return "Divine Shield";
        case 0x41486164: return "Devotion Aura";
        case 0x41487265: return "Resurrection";
        case 0x416D696C: return "Call to Arms";
        case 0x416D6963: return "Call To Arms";
        case 0x41626F66: return "Burning Oil";
        case 0x4162736B: return "Berserk";
        case 0x5362736B: return "Berserker Upgrade";
        case 0x41726272: return "Reinforced Burrows Upgrade";
        case 0x41617374: return "Ancestral Spirit";
        case 0x41646368: return "Disenchant";
        case 0x4164636E: return "Disenchant";
        case 0x41637066: return "Corporeal Form";
        case 0x41657466: return "Ethereal Form";
        case 0x4173706C: return "Spirit Link";
        case 0x4170616B: return "Pack Mule";
        case 0x416C6971: return "Liquid Fire";
        case 0x4175636F: return "Unstable Concoction";
        case 0x414F6877: return "Healing Wave";
        case 0x414F6878: return "Hex";
        case 0x414F7377: return "Serpent Ward";
        case 0x414F7664: return "Big Bad Voodoo";
        case 0x41776662: return "Firebolt";
        case 0x41636861: return "Chaos";
        case 0x4163686C: return "Chaos Cargo Load";
        case 0x41776172: return "Pulverize";
        case 0x4162746C: return "Battle Stations";
        case 0x41737464: return "Stand Down";
        case 0x41656E73: return "Ensnare";
        case 0x41646576: return "Devour";
        case 0x41707267: return "Purge";
        case 0x416C7368: return "Lightning Shield";
        case 0x41626C6F: return "Bloodlust";
        case 0x41657965: return "Sentry Ward";
        case 0x41737461: return "Stasis Trap";
        case 0x41687764: return "Healing Ward";
        case 0x416F6172: return "Healing Ward Aura";
        case 0x4176656E: return "Envenomed Spears";
        case 0x41706F69: return "Poison Sting";
        case 0x41706F32: return "Poison Sting";
        case 0x416E6974: return "Tracking";
        case 0x41737069: return "Spiked Barricades";
        case 0x4173616C: return "Pillage";
        case 0x41616B62: return "War Drums";
        case 0x414F776B: return "Wind Walk";
        case 0x414F6D69: return "Mirror Image";
        case 0x414F6372: return "Critical Strike";
        case 0x414F7777: return "Bladestorm";
        case 0x414F636C: return "Chain Lightning";
        case 0x414F6673: return "Far Sight";
        case 0x414F7366: return "Feral Spirit";
        case 0x414F6571: return "Earthquake";
        case 0x414F7368: return "Shockwave";
        case 0x414F6165: return "Endurance Aura";
        case 0x414F7265: return "Reincarnation";
        case 0x414F7773: return "War Stomp";
        case 0x41766E67: return "Spirit of Vengeance";
        case 0x416D666C: return "Mana Flare";
        case 0x41707368: return "Phase Shift";
        case 0x4165746C: return "Ethereal";
        case 0x41737031: return "Sphere";
        case 0x41737032: return "Sphere";
        case 0x41737033: return "Sphere";
        case 0x41737034: return "Sphere";
        case 0x41737035: return "Sphere";
        case 0x41737036: return "Sphere";
        case 0x41677261: return "War Club";
        case 0x4173736B: return "Hardened Skin";
        case 0x4172736B: return "Resistant Skin";
        case 0x41746175: return "Taunt";
        case 0x4145626C: return "Blink";
        case 0x4145666B: return "Fan of Knives";
        case 0x41457368: return "Shadow Strike";
        case 0x41457376: return "Vengeance";
        case 0x536C6F32: return "Load Wisp";
        case 0x416D676C: return "Moon Glaive";
        case 0x416D6772: return "Moon Glaive";
        case 0x4173706F: return "Slow Poison";
        case 0x4173686D: return "Shadow Meld";
        case 0x5373686D: return "Shadow Meld";
        case 0x41686964: return "Shadow Meld";
        case 0x4165736E: return "Sentinel";
        case 0x41657372: return "Sentinel";
        case 0x41656174: return "Eat Tree";
        case 0x416D6274: return "Replenish Mana and Life";
        case 0x41776861: return "Gather";
        case 0x41776832: return "Gather";
        case 0x4164746E: return "Detonate";
        case 0x41776865: return "Heal";
        case 0x41656E74: return "Entangle Gold Mine";
        case 0x41656E63: return "Load";
        case 0x41726F6F: return "Root";
        case 0x41627266: return "Bear Form";
        case 0x41726176: return "Storm Crow Form";
        case 0x4161646D: return "Abolish Magic";
        case 0x416D696D: return "Spell Immunity";
        case 0x41756C74: return "Ultravision";
        case 0x41636F61: return "Mount Hippogryph";
        case 0x41636F32: return "Mount Hippogryph";
        case 0x41636F68: return "Pick up Archer";
        case 0x41636F33: return "Pick up Archer";
        case 0x41646563: return "Dismount";
        case 0x41636F72: return "Corrosive Breath";
        case 0x41456D62: return "Mana Burn";
        case 0x4145696D: return "Immolation";
        case 0x41456576: return "Evasion";
        case 0x41456D65: return "Metamorphosis";
        case 0x4145496C: return "Metamorphosis";
        case 0x41457669: return "Metamorphosis";
        case 0x41456572: return "Entangling Roots";
        case 0x4145666E: return "Force of Nature";
        case 0x41456168: return "Thorns Aura";
        case 0x41457471: return "Tranquility";
        case 0x41457374: return "Scout";
        case 0x41486661: return "Searing Arrows";
        case 0x41456172: return "Trueshot Aura";
        case 0x41457366: return "Starfall";
        case 0x41457362: return "Starfall";
        case 0x41666165: return "Faerie Fire";
        case 0x41666132: return "Faerie Fire";
        case 0x41637963: return "Cyclone";
        case 0x4172656A: return "Rejuvenation";
        case 0x4172656E: return "Renew";
        case 0x41726F61: return "Roar";
        case 0x41726132: return "Roar";
        case 0x416C6974: return "Lightning Attack";
        case 0x41727062: return "Replenish";
        case 0x4172706C: return "Essence of Blight";
        case 0x4172706D: return "Spirit Touch";
        case 0x41657868: return "Exhume Corpses";
        case 0x416D6232: return "Replenish Mana";
        case 0x41617665: return "Destroyer Form ";
        case 0x4166616B: return "Orb of Annihilation";
        case 0x4164766D: return "Devour Magic";
        case 0x41616272: return "Aura of Blight";
        case 0x41616273: return "Absorb Mana";
        case 0x41627572: return "Burrow";
        case 0x41627532: return "Burrow";
        case 0x41627533: return "Burrow";
        case 0x4155696D: return "Impale";
        case 0x41557473: return "Spiked Carapace";
        case 0x41556362: return "Carrion Beetles";
        case 0x41556C73: return "Locust Swarm";
        case 0x416D7463: return "Cargo Hold";
        case 0x41747275: return "True Sight";
        case 0x41616861: return "Gather";
        case 0x41756E73: return "Unsummon Building";
        case 0x41677964: return "Create Corpse";
        case 0x416C616D: return "Sacrifice";
        case 0x41736163: return "Sacrifice";
        case 0x4163616E: return "Cannibalize";
        case 0x41636E32: return "Cannibalize";
        case 0x41737061: return "Spider Attack";
        case 0x41776562: return "Web";
        case 0x4173746E: return "Stone Form";
        case 0x416D656C: return "Get Corpse";
        case 0x416D6564: return "Drop Corpse";
        case 0x4161706C: return "Disease Cloud";
        case 0x41617031: return "Disease Cloud";
        case 0x41617032: return "Disease Cloud";
        case 0x41617033: return "Disease Cloud";
        case 0x41617034: return "Disease Cloud";
        case 0x41707473: return "Disease Cloud";
        case 0x41667262: return "Frost Breath";
        case 0x41667261: return "Frost Attack";
        case 0x4166727A: return "Freezing Breath";
        case 0x41726169: return "Raise Dead";
        case 0x41756866: return "Unholy Frenzy";
        case 0x53756866: return "Unholy Frenzy";
        case 0x41637273: return "Curse";
        case 0x41616D73: return "Anti-magic Shell";
        case 0x41706F73: return "Possession";
        case 0x41556463: return "Death Coil";
        case 0x41556175: return "Unholy Aura";
        case 0x41556470: return "Death Pact";
        case 0x4155616E: return "Animate Dead";
        case 0x41556373: return "Carrion Swarm";
        case 0x4155736C: return "Sleep";
        case 0x41556176: return "Vampiric Aura";
        case 0x4155666E: return "Frost Nova";
        case 0x41556661: return "Frost Armor";
        case 0x41556675: return "Frost Armor";
        case 0x41556472: return "Dark Ritual";
        case 0x41556464: return "Death And Decay";
        case 0x41637269: return "Cripple";
        case 0x53637269: return "Cripple";
        case 0x41727374: return "Restore";
        case 0x4155696E: return "Inferno";
        case 0x41496766: return "Glyph of Fortification";
        case 0x41496775: return "Glyph of Fortification";
        case 0x4161736C: return "Slow Aura";
        case 0x41746467: return "Building Damage Aura";
        case 0x41747370: return "Tornado Spin";
        case 0x41747761: return "Tornado Wander";
        case 0x414E616B: return "Quill Spray";
        case 0x414E626C: return "Blink";
        case 0x41636865: return "Ray of Disruption";
        case 0x41627535: return "Burrow";
        case 0x41437061: return "Parasite";
        case 0x4143736D: return "Siphon Mana";
        case 0x41436465: return "Devour Magic";
        case 0x416E736B: return "Hardened Skin";
        case 0x414E6D73: return "Mana Shield";
        case 0x414E7266: return "Rain of Fire";
        case 0x41437267: return "Rain of Fire";
        case 0x414E6661: return "Frost Arrows";
        case 0x41486361: return "Cold Arrows";
        case 0x414E6874: return "Howl of Terror";
        case 0x41636874: return "Howl of Terror";
        case 0x414E6361: return "Cleaving Attack";
        case 0x41436365: return "Cleaving Attack";
        case 0x414E646F: return "Doom";
        case 0x414E6566: return "Storm, Earth, And Fire";
        case 0x414E776B: return "Wind Walk";
        case 0x414E7461: return "Taunt";
        case 0x4143626E: return "Banish";
        case 0x414E6472: return "Life Drain";
        case 0x41436472: return "Life Drain";
        case 0x414E6266: return "Breath of Fire";
        case 0x4169756E: return "Unit Inventory";
        case 0x41696F6E: return "Unit Inventory";
        case 0x4169686E: return "Unit Inventory";
        case 0x4169656E: return "Unit Inventory";
        case 0x414E7367: return "Summon Bear";
        case 0x414E7371: return "Summon Quilbeast";
        case 0x414E7377: return "Summon Hawk";
        case 0x414E7374: return "Stampede";
        case 0x41436878: return "Hex";
        case 0x41656E77: return "Entangling Roots";
        case 0x41436876: return "Healing Wave";
        case 0x41437369: return "Silence";
        case 0x41436D66: return "Mana Shield";
        case 0x41436362: return "Frost Bolt";
        case 0x41436266: return "Breath of Frost";
        case 0x41436263: return "Breath of Fire";
        case 0x41436673: return "Flame Strike";
        case 0x414E6673: return "Flame Strike";
        case 0x41436D70: return "Impale";
        case 0x41496E76: return "Inventory";
        case 0x414E7468: return "Spiked Shell";
        case 0x414E7432: return "Spiked Shell";
        case 0x414E6D72: return "Mind Rot";
        case 0x414E6462: return "Drunken Brawler";
        case 0x414E6468: return "Drunken Haze";
        case 0x414E7369: return "Silence";
        case 0x414E6261: return "Black Arrow";
        case 0x4143626B: return "Black Arrow";
        case 0x41436368: return "Charm";
        case 0x414E6368: return "Charm";
        case 0x414E6D6F: return "Monsoon";
        case 0x41436D6F: return "Monsoon";
        case 0x414E776D: return "Watery Minion";
        case 0x41736C70: return "Summon Prawns";
        case 0x414E746F: return "Tornado";
        case 0x41436877: return "Healing Ward";
        case 0x41437232: return "Rejuvenation";
        case 0x41436D32: return "Spell Immunity";
        case 0x41436D33: return "Spell Immunity";
        case 0x41726E67: return "Revenge";
        case 0x41647467: return "True Sight";
        case 0x414E7472: return "True Sight";
        case 0x4162676D: return "Blighted Gold Mine Ability";
        case 0x4165676D: return "Entangled Gold Mine Ability";
        case 0x41746F6C: return "Tree of Life upgrade ability";
        case 0x41777270: return "Waygate ability";
        case 0x414E6463: return "Dark Conversion";
        case 0x534E6463: return "Dark Conversion";
        case 0x414E736C: return "Soul Preservation";
        case 0x534E696E: return "Inferno";
        case 0x414E6664: return "Finger of Death";
        case 0x41436664: return "Finger of Pain";
        case 0x41436633: return "Finger of Pain";
        case 0x41666F64: return "Finger of Death";
        case 0x414E6470: return "Dark Portal";
        case 0x414E7263: return "Rain of Chaos";
        case 0x414E7233: return "Rain of Chaos";
        case 0x41436176: return "Devotion Aura";
        case 0x41636864: return "Cargo Hold Death";
        case 0x416C6F61: return "Load";
        case 0x4164726F: return "Unload";
        case 0x5364726F: return "Unload";
        case 0x41647269: return "Unload Instant";
        case 0x41736C61: return "Sleep Always";
        case 0x41647663: return "Devour Cargo";
        case 0x414E7069: return "Permanent Immolation";
        case 0x41706967: return "Permanent Immolation";
        case 0x4162756E: return "Cargo Hold ";
        case 0x5362746C: return "Battle Stations";
        case 0x41636172: return "Cargo Hold";
        case 0x416E6474: return "Reveal";
        case 0x414E676C: return "Exchange Gold for Lumber";
        case 0x414E6C67: return "Exchange Lumber for Gold";
        case 0x414E7265: return "Life Regeneration Aura";
        case 0x414E726C: return "Life Regeneration";
        case 0x416E6575: return "Select Hero";
        case 0x416E6532: return "Select Unit";
        case 0x414E696E: return "Inferno";
        case 0x414E7370: return "Spy";
        case 0x41736473: return "Kaboom!";
        case 0x416D7266: return "Crow Form";
        case 0x416E6865: return "Heal";
        case 0x41437377: return "Slow";
        case 0x41437463: return "Slam";
        case 0x41437432: return "Slam";
        case 0x41437462: return "Hurl Boulder";
        case 0x41436272: return "Berserker Rage";
        case 0x41436262: return "Bloodlust";
        case 0x41667A79: return "Frenzy";
        case 0x4143626C: return "Bloodlust";
        case 0x4143656E: return "Ensnare";
        case 0x41436476: return "Devour";
        case 0x41437370: return "Sleep";
        case 0x414E726E: return "Reincarnation";
        case 0x414E6662: return "Firebolt";
        case 0x41736F64: return "Spawn Skeleton";
        case 0x41737370: return "Spawn Spiderlings";
        case 0x41737064: return "Spawn Spiders";
        case 0x41737079: return "Spawn Hydra";
        case 0x41737074: return "Spawn Hydra Hatchling";
        case 0x414F6163: return "Command Aura";
        case 0x41436163: return "Command Aura";
        case 0x41436164: return "Animate Dead";
        case 0x4143726E: return "Reincarnation";
        case 0x416D6264: return "Mana Burn";
        case 0x416D6E62: return "Mana Burn";
        case 0x416D6262: return "Mana Burn";
        case 0x41646461: return "AOE damage upon death";
        case 0x4167686F: return "Ghost";
        case 0x41657468: return "Ghost";
        case 0x41676C64: return "Gold Mine ability";
        case 0x416D696E: return "Mine - exploding";
        case 0x41706976: return "Permanent Invisibility";
        case 0x4172746E: return "Return";
        case 0x4176756C: return "Invulnerable";
        case 0x4177616E: return "Wander";
        case 0x41556D64: return "Dark Summoning ";
        case 0x4161726D: return "Mana Regeneration Aura";
        case 0x41436E72: return "Life Regeneration Aura";
        case 0x53636832: return "Cargo Hold";
        case 0x53636833: return "Cargo Hold";
        case 0x53636834: return "Cargo Hold";
        case 0x53636835: return "Cargo Hold";
        case 0x41726764: return "Return Gold";
        case 0x4172676C: return "Return Gold and Lumber";
        case 0x41726C6D: return "Return Lumber";
        case 0x416D6E7A: return "AOE damage upon death";
        case 0x4143616D: return "Anti-magic Shell";
        case 0x41436261: return "Brilliance Aura";
        case 0x41436268: return "Bash";
        case 0x414E6268: return "Bash";
        case 0x414E6232: return "Maul";
        case 0x41436174: return "Trueshot Aura";
        case 0x41626C69: return "Blight";
        case 0x41626473: return "Blight Dispel Small";
        case 0x4162646C: return "Blight Dispel Large";
        case 0x41626773: return "Blight Growth Small";
        case 0x4162676C: return "Blight Growth Large";
        case 0x4143627A: return "Blizzard";
        case 0x4143636E: return "Cannibalize";
        case 0x41436361: return "Carrion Swarm";
        case 0x4143636C: return "Chain Lightning";
        case 0x41436377: return "Cold Arrows";
        case 0x41436372: return "Cripple";
        case 0x41436374: return "Critical Strike";
        case 0x41436373: return "Curse";
        case 0x41436379: return "Cyclone";
        case 0x53436331: return "Cyclone";
        case 0x416D6E78: return "AOE damage upon death";
        case 0x534E6464: return "Death And Decay";
        case 0x41436463: return "Death Coil";
        case 0x4164736D: return "Dispel Magic";
        case 0x4143646D: return "Abolish Magic";
        case 0x41436432: return "Abolish Magic";
        case 0x41436473: return "Divine Shield";
        case 0x534E6571: return "Earthquake";
        case 0x53436165: return "Endurance Aura";
        case 0x41656E72: return "Entangling Roots";
        case 0x41436576: return "Evasion";
        case 0x41436573: return "Evasion";
        case 0x41436666: return "Faerie Fire";
        case 0x41437366: return "Feral Spirit";
        case 0x41437339: return "Feral Spirit";
        case 0x41436662: return "Firebolt";
        case 0x41436672: return "Force of Nature";
        case 0x41436661: return "Frost Armor";
        case 0x41436632: return "Frost Armor";
        case 0x4143666E: return "Frost Nova";
        case 0x41687232: return "Harvest";
        case 0x41687233: return "Harvest";
        case 0x416E6831: return "Heal";
        case 0x416E6832: return "Heal";
        case 0x4143696D: return "Immolation";
        case 0x41436966: return "Inner Fire";
        case 0x41436C73: return "Lightning Shield";
        case 0x536C6F61: return "Load";
        case 0x536C6F33: return "Load";
        case 0x41436D69: return "Spell Immunity";
        case 0x41437079: return "Polymorph";
        case 0x41437073: return "Possession";
        case 0x41437076: return "Pulverize";
        case 0x41437075: return "Purge";
        case 0x41437266: return "Rain of Fire";
        case 0x41437264: return "Raise Dead";
        case 0x4143726A: return "Rejuvenation";
        case 0x41687270: return "Repair";
        case 0x4143726F: return "Roar";
        case 0x41437231: return "Roar";
        case 0x41726F31: return "Root";
        case 0x41726F32: return "Root";
        case 0x41437361: return "Searing Arrows";
        case 0x41736964: return "Sell Items";
        case 0x41737564: return "Sell Units";
        case 0x41437368: return "Shockwave";
        case 0x41437374: return "Shockwave";
        case 0x4143736C: return "Sleep";
        case 0x41436168: return "Thorns Aura";
        case 0x41437561: return "Unholy Aura";
        case 0x41437566: return "Unholy Frenzy";
        case 0x53437661: return "Life Steal";
        case 0x41437670: return "Vampiric Aura";
        case 0x41777273: return "War Stomp";
        case 0x41777268: return "War Stomp";
        case 0x41777267: return "War Stomp";
        case 0x41437673: return "Envenomed Weapons";
        case 0x41437762: return "Web";
        case 0x41436376: return "Crushing Wave";
        case 0x41436332: return "Crushing Wave";
        case 0x41436333: return "Crushing Wave";
        case 0x41437765: return "Summon Sea Elemental";
        case 0x416E6569: return "Select User";
        case 0x41706D66: return "Phoenix Fire";
        case 0x4143726B: return "Resistant Skin";
        case 0x4143736B: return "Resistant Skin";
        case 0x414E666C: return "Forked Lightning";
        case 0x4143666C: return "Forked Lightning";
        case 0x41616C6C: return "Shop Sharing/ Allied Bldg.";
        case 0x41626474: return "Burrow Detection";
        case 0x41706974: return "Shop Purchase Item";
        case 0x416D6F75: return "Mount";
        case 0x41686172: return "Harvest";
        case 0x4168726C: return "Harvest";
        case 0x41726576: return "Revive Hero";
        case 0x41617761: return "Revive Hero Instantly";
        case 0x41646574: return "Detector";
        case 0x41647431: return "Detector";
        case 0x41647461: return "Reveal";
        case 0x41726570: return "Repair";
        case 0x52687373: return "Research Control Magic";
        case 0x52686D65: return "Upgrade to Iron Forged Swords/Upgrade to Steel Forged Swords/Upgrade to Mithril Forged Swords";
        case 0x52687261: return "Upgrade to Black Gunpowder/Upgrade to Refined Gunpowder/Upgrade to Imbued Gunpowder";
        case 0x52686172: return "Upgrade to Iron Plating/Upgrade to Steel Plating/Upgrade to Mithril Plating";
        case 0x52686C61: return "Upgrade to Studded Leather Armor/Upgrade to Reinforced Leather Armor/Upgrade to Dragonhide Armor";
        case 0x52686163: return "Upgrade to Improved Masonry/Upgrade to Advanced Masonry/Upgrade to Imbued Masonry";
        case 0x52686762: return "Research Flying Machine Bombs";
        case 0x52686C68: return "Improved Lumber Harvesting/Advanced Lumber Harvesting";
        case 0x52686465: return "Research Defend";
        case 0x5268616E: return "Research Animal War Training";
        case 0x52687074: return "Priest Adept Training/Priest Master Training";
        case 0x52687374: return "Sorceress Adept Training/Sorceress Master Training";
        case 0x52687269: return "Upgrade to Long Rifles";
        case 0x52687365: return "Research Magic Sentry";
        case 0x5268666C: return "Research Flare";
        case 0x52686862: return "Research Storm Hammers";
        case 0x52687274: return "Research Barrage";
        case 0x5268706D: return "Research Backpack";
        case 0x52686663: return "Research Flak Cannons";
        case 0x52686673: return "Research Fragmentation Shards";
        case 0x52686364: return "Research Cloud";
        case 0x526F6D65: return "Upgrade to Steel Melee Weapons/Upgrade to Thorium Melee Weapons/Upgrade to Arcanite Melee Weapons";
        case 0x526F7261: return "Upgrade to Steel Ranged Weapons/Upgrade to Thorium Ranged Weapons/Upgrade to Arcanite Ranged Weapons";
        case 0x526F6172: return "Upgrade to Steel Unit Armor/Upgrade to Thorium Unit Armor/Upgrade to Arcanite Unit Armor";
        case 0x5277646D: return "Upgrade War Drums";
        case 0x526F7067: return "Pillage";
        case 0x526F6273: return "Research Berserker Strength";
        case 0x526F7773: return "Research Pulverize";
        case 0x526F656E: return "Research Ensnare";
        case 0x526F7673: return "Research Envenomed Spears";
        case 0x526F7764: return "Witch Doctor Adept Training/Witch Doctor Master Training";
        case 0x526F7374: return "Shaman Adept Training/Shaman Master Training";
        case 0x526F7370: return "Upgrade to Spiked Barricades/Upgrade to Improved Spiked Barricades/Upgrade to Advanced Spiked Barricades";
        case 0x526F7472: return "Research Troll Regeneration/ Research Improved Troll Regeneration/ Research Advanced Troll Regeneration";
        case 0x526F6C66: return "Research Liquid Fire";
        case 0x526F706D: return "Research Backpack";
        case 0x526F7774: return "Spirit Walker Adept Training/Spirit Walker Master Training";
        case 0x526F626B: return "Berserker Upgrade";
        case 0x526F7262: return "Reinforced Defenses";
        case 0x526F6266: return "Burning Oil";
        case 0x5265736D: return "Upgrade to Strength of the Moon/Upgrade to Improved Strength of the Moon/Upgrade to Advanced Strength of the Moon";
        case 0x52657377: return "Upgrade to Strength of the Wild/Upgrade to Improved Strength of the Wild/Upgrade to Advanced Strength of the Wild";
        case 0x52656D61: return "Upgrade to Moon Armor/Upgrade to Improved Moon Armor/Upgrade to Advanced Moon Armor";
        case 0x52657268: return "Upgrade to Reinforced Hides/Upgrade to Improved Reinforced Hides/Upgrade to Advanced Reinforced Hides";
        case 0x52657576: return "Upgrade to Ultravision";
        case 0x52656E62: return "Research Nature's Blessing";
        case 0x52656962: return "Research Improved Bows";
        case 0x52656D6B: return "Research Marksmanship";
        case 0x52657363: return "Research Sentinel";
        case 0x52656D67: return "Upgrade Moon Glaive";
        case 0x52656474: return "Druid of the Talon Adept Training/Druid of the Talon Master Training";
        case 0x52656463: return "Druid of the Claw Adept Training/Druid of the Claw Master Training";
        case 0x52657369: return "Research Abolish Magic";
        case 0x52656874: return "Research Hippogryph Taming";
        case 0x52656362: return "Research Corrosive Breath";
        case 0x52657062: return "Research Vorpal Blades";
        case 0x52657273: return "Research Resistant Skin";
        case 0x52656873: return "Research Hardened Skin";
        case 0x52656562: return "Research Mark of the Claw";
        case 0x52656563: return "Research Mark of the Talon";
        case 0x52657773: return "Research Well Spring";
        case 0x5265706D: return "Research Backpack";
        case 0x52757370: return "Research Destroyer Form";
        case 0x52756D65: return "Upgrade to Unholy Strength/Upgrade to Improved Unholy Strength/Upgrade to Advanced Unholy Strength";
        case 0x52757261: return "Upgrade to Creature Attack/Upgrade to Improved Creature Attack/Upgrade to Advanced Creature Attack";
        case 0x52756172: return "Upgrade to Unholy Armor/Upgrade to Improved Unholy Armor/Upgrade to Advanced Unholy Armor";
        case 0x52756372: return "Upgrade to Creature Carapace/Upgrade to Improved Creature Carapace/Upgrade to Advanced Creature Carapace";
        case 0x52756163: return "Research Cannibalize";
        case 0x52756766: return "Research Ghoul Frenzy";
        case 0x52757762: return "Research Web";
        case 0x52757366: return "Research Stone Form";
        case 0x52756E65: return "Necromancer Adept Training/Necromancer Master Training";
        case 0x52756261: return "Banshee Adept Training/Banshee Master Training";
        case 0x52756662: return "Research Freezing Breath";
        case 0x5275736C: return "Research Skeletal Longevity";
        case 0x52757063: return "Research Disease Cloud";
        case 0x5275736D: return "Research Skeletal Mastery";
        case 0x52756275: return "Research Burrow";
        case 0x52756578: return "Research Exhume Corpses";
        case 0x5275706D: return "Research Backpack";
        case 0x616D7263: return "Purchase Amulet of Recall";
        case 0x616E6B68: return "Purchase Ankh of Reincarnation";
        case 0x63636D64: return "Purchase Scepter of Mastery";
        case 0x63697269: return "Purchase Robe of the Magi";
        case 0x636B6E67: return "Purchase Crown of Kings";
        case 0x636C7364: return "Purchase Cloak of Shadows";
        case 0x63727973: return "Purchase Crystal Ball";
        case 0x64657363: return "Purchase Dagger of Escape";
        case 0x666C6167: return "Purchase Human Flag";
        case 0x6E666C67: return "Purchase Night Elf Flag";
        case 0x6F666C67: return "Purchase Orc Flag";
        case 0x75666C67: return "Purchase Undead Flag";
        case 0x67656D74: return "Purchase Gem of True Seeing";
        case 0x676F626D: return "Purchase Goblin Land Mines";
        case 0x67736F75: return "Purchase Soul Gem";
        case 0x67757669: return "Purchase Glyph of Ultravision";
        case 0x67666F72: return "Purchase Glyph of Fortification";
        case 0x736F756C: return "Purchase Soul";
        case 0x6D647062: return "Purchase Medusa Pebble";
        case 0x72616731: return "Purchase Slippers of Agility +3";
        case 0x72617433: return "Purchase Claws of Attack +3";
        case 0x72696E31: return "Purchase Mantle of Intelligence +3";
        case 0x72646531: return "Purchase Ring of Protection +2";
        case 0x72646532: return "Purchase Ring of Protection +3";
        case 0x72646533: return "Purchase Ring of Protection +4";
        case 0x72687468: return "Purchase Khadgar's Gem of Health";
        case 0x72737431: return "Purchase Gauntlets of Ogre Strength +3";
        case 0x6F666972: return "Purchase Orb of Fire";
        case 0x6F66726F: return "Purchase Orb of Frost";
        case 0x6F6C6967: return "Purchase Orb of Lightning";
        case 0x6F6C6932: return "Purchase Orb of Lightning";
        case 0x6F76656E: return "Purchase Orb of Venom";
        case 0x6F646566: return "Purchase Orb of Darkness";
        case 0x6F636F72: return "Purchase Orb of Corruption";
        case 0x70646976: return "Purchase Potion of Divinity";
        case 0x70686561: return "Purchase Potion of Healing";
        case 0x70676865: return "Purchase Potion of Greater Healing";
        case 0x70696E76: return "Purchase Potion of Invisibility";
        case 0x7067696E: return "Purchase Potion of Greater Invisibility";
        case 0x706D616E: return "Purchase Potion of Mana";
        case 0x70676D61: return "Purchase Potion of Greater Mana";
        case 0x706E7675: return "Purchase Potion of Invulnerability";
        case 0x706E766C: return "Purchase Potion of Lesser Invulnerability";
        case 0x70726573: return "Purchase Potion of Restoration";
        case 0x70737064: return "Purchase Potion of Speed";
        case 0x726C6966: return "Purchase Ring of Regeneration";
        case 0x7277697A: return "Purchase Sobi Mask";
        case 0x73666F67: return "Purchase Horn of the Clouds";
        case 0x72686531: return "Purchase Rune of Lesser Healing";
        case 0x72686532: return "Purchase Rune of Healing";
        case 0x72686533: return "Purchase Rune of Greater Healing";
        case 0x73686561: return "Purchase Scroll of Healing";
        case 0x736D616E: return "Purchase Scroll of Mana";
        case 0x726D616E: return "Purchase Rune of Mana";
        case 0x726D6132: return "Purchase Rune of Greater Mana";
        case 0x7370726F: return "Purchase Scroll of Protection";
        case 0x73726573: return "Purchase Scroll of Restoration";
        case 0x72726573: return "Purchase Rune of Restoration";
        case 0x7373696C: return "Purchase Staff of Silence";
        case 0x73747770: return "Purchase Scroll of Town Portal";
        case 0x74656C73: return "Purchase Goblin Night Scope";
        case 0x74646578: return "Purchase Tome of Agility";
        case 0x74657870: return "Purchase Tome of Experience";
        case 0x74696E74: return "Purchase Tome of Intelligence";
        case 0x746B6E6F: return "Purchase Tome of Power";
        case 0x74737472: return "Purchase Tome of Strength";
        case 0x77617264: return "Purchase Warsong Battle Drums";
        case 0x77696C6C: return "Purchase Wand of Illusion";
        case 0x776E6567: return "Purchase Wand of Negation";
        case 0x72646973: return "Purchase Rune of Dispel Magic";
        case 0x72776174: return "Purchase Rune of the Watcher";
        case 0x66677264: return "Purchase Drake Egg";
        case 0x66677267: return "Purchase Stone Token";
        case 0x66676467: return "Purchase Demonic Figurine";
        case 0x66676668: return "Purchase Spiked Collar";
        case 0x6667736B: return "Purchase Book of the Dead";
        case 0x6B74726D: return "Purchase Urn of King Terenas";
        case 0x73656872: return "Purchase the Heart of Searinox";
        case 0x617A6872: return "Purchase Heart of Aszune";
        case 0x636E686E: return "Purchase Horn of Cenarius";
        case 0x676C736B: return "Purchase Skull of Gul'dan";
        case 0x656E6773: return "Purchase Enchanted Gemstone";
        case 0x6B336D31: return "Purchase Mooncrystal";
        case 0x6B336D32: return "Purchase Partial Key of Three Moons";
        case 0x6B336D33: return "Purchase Key of Three Moons";
        case 0x6D6F6474: return "Purchase Mask of Death";
        case 0x73616E64: return "Purchase Scroll of Animate Dead";
        case 0x73727263: return "Purchase Scroll of Resurrection";
        case 0x72726531: return "Purchase Rune of Lesser Resurrection";
        case 0x72726532: return "Purchase Rune of Greater Resurrection";
        case 0x7273706C: return "Purchase Rune of Spirit Link";
        case 0x73726F72: return "Purchase Scroll of the Beast";
        case 0x696E6673: return "Purchase Inferno Stone";
        case 0x73686172: return "Purchase Ice Shard";
        case 0x77696C64: return "Purchase Amulet of the Wild";
        case 0x77737764: return "Purchase Sentry Wards";
        case 0x77687764: return "Purchase Healing Wards";
        case 0x776C7364: return "Purchase Wand of Lightning Shield";
        case 0x77637963: return "Purchase Wand of the Wind";
        case 0x726E6563: return "Purchase Rod of Necromancy";
        case 0x70616D73: return "Purchase Anti-magic Potion";
        case 0x636C666D: return "Purchase Cloak of Flames";
        case 0x6576746C: return "Purchase Talisman of Evasion";
        case 0x6E737069: return "Purchase Necklace of Spell Immunity";
        case 0x6C687374: return "Purchase the Lion Horn of Stormwind";
        case 0x6B70696E: return "Purchase Khadgar's Pipe of Insight";
        case 0x73626368: return "Purchase Scourge Bone Chimes";
        case 0x61666163: return "Purchase Alleria's Flute of Accuracy";
        case 0x616A656E: return "Purchase Ancient Janggo of Endurance";
        case 0x6C676468: return "Purchase Legion Doom-Horn";
        case 0x6863756E: return "Purchase Hood of Cunning";
        case 0x6D636F75: return "Purchase Medallion of Courage";
        case 0x6876616C: return "Purchase Helm of Valor";
        case 0x636E6F62: return "Purchase Circlet of Nobility";
        case 0x70727674: return "Purchase Periapt of Vitality";
        case 0x74677870: return "Purchase Tome of Greater Experience";
        case 0x6D6E7374: return "Purchase Mana Stone";
        case 0x686C7374: return "Purchase Health Stone";
        case 0x74706F77: return "Purchase Tome of Knowledge";
        case 0x74737432: return "Purchase Tome of Strength +2";
        case 0x74696E32: return "Purchase Tome of Intelligence +2";
        case 0x74647832: return "Purchase Tome of Agility +2";
        case 0x72646530: return "Purchase Ring of Protection +1";
        case 0x72646534: return "Purchase Ring of Protection +5";
        case 0x72617436: return "Purchase Claws of Attack +6";
        case 0x72617439: return "Purchase Claws of Attack +9";
        case 0x72617463: return "Purchase Claws of Attack +12";
        case 0x72617466: return "Purchase Claws of Attack +15";
        case 0x6D616E68: return "Purchase Manual of Health";
        case 0x706D6E61: return "Purchase Pendant of Mana";
        case 0x70656E72: return "Purchase Pendant of Energy";
        case 0x6763656C: return "Purchase Gloves of Haste";
        case 0x6C656467: return "Purchase Gerard's Lost Ledger";
        case 0x746F7477: return "Purchase Talisman of the Wild";
        case 0x6B79626C: return "Purchase Blood Key";
        case 0x6B796768: return "Purchase Ghost Key";
        case 0x6B79736E: return "Purchase Sun Key";
        case 0x6B796D6E: return "Purchase Moon Key";
        case 0x70686C74: return "Purchase Phat Lewt";
        case 0x676F7072: return "Purchase Glyph of Purification";
        case 0x63686573: return "Purchase the Cheese";
        case 0x6D6C7374: return "Purchase Maul of Strength";
        case 0x726E7370: return "Purchase Ring of Superiority";
        case 0x736B7368: return "Purchase Skull Shield";
        case 0x7664646C: return "Purchase Voodoo Doll";
        case 0x7370726E: return "Purchase Spider Ring";
        case 0x746D6D74: return "Purchase Totem of Might";
        case 0x616E6667: return "Purchase Ancient Figurine";
        case 0x6C6E726E: return "Purchase Lion's Ring";
        case 0x69776272: return "Purchase Ironwood Branch";
        case 0x6A64726E: return "Purchase Jade Ring";
        case 0x64727068: return "Purchase Druid Pouch";
        case 0x68736C76: return "Purchase Healing Salve";
        case 0x70636C72: return "Purchase Clarity Potion";
        case 0x706C636C: return "Purchase Lesser Clarity Potion";
        case 0x72656A31: return "Purchase Minor Replenishment Potion";
        case 0x72656A32: return "Purchase Lesser Replenishment Potion";
        case 0x72656A33: return "Purchase Replenishment Potion";
        case 0x72656A34: return "Purchase Greater Replenishment Potion";
        case 0x72656A35: return "Purchase Lesser Scroll of Replenishment";
        case 0x72656A36: return "Purchase Greater Scroll of Replenishment";
        case 0x73726567: return "Purchase Scroll of Regeneration";
        case 0x676F6C64: return "Purchase Gold Coins";
        case 0x6C6D6272: return "Purchase Bundle of Lumber";
        case 0x6667756E: return "Purchase Flare Gun";
        case 0x706F6D6E: return "Purchase Potion of Omniscience";
        case 0x676F6D6E: return "Purchase Glyph of Omniscience";
        case 0x776E6575: return "Purchase Wand of Neutralization";
        case 0x73696C6B: return "Purchase Spider Silk Broach";
        case 0x6C757265: return "Purchase Monster Lure";
        case 0x736B756C: return "Purchase Sacrificial Skull";
        case 0x6D6F6F6E: return "Purchase Moonstone";
        case 0x76616D70: return "Purchase Vampiric Potion";
        case 0x776F6D73: return "Purchase Wand of Mana Stealing";
        case 0x74636173: return "Purchase Tiny Castle";
        case 0x74677268: return "Purchase Tiny Great Hall";
        case 0x74736374: return "Purchase Ivory Tower";
        case 0x77736873: return "Purchase Wand of Shadowsight";
        case 0x74726574: return "Purchase Tome of Retraining";
        case 0x736E6567: return "Purchase Staff of Negation";
        case 0x7374656C: return "Purchase Staff of Teleportation";
        case 0x73707265: return "Purchase Staff of Preservation";
        case 0x6D637269: return "Purchase Mechanical Critter";
        case 0x73707368: return "Purchase Amulet of Spell Shield";
        case 0x72737073: return "Purchase Rune of Shielding";
        case 0x73626F6B: return "Purchase Spell Book";
        case 0x7373616E: return "Purchase Staff of Sanctuary";
        case 0x73686173: return "Purchase Scroll of Speed";
        case 0x72737064: return "Purchase Rune of Speed";
        case 0x64757374: return "Purchase Dust of Appearance";
        case 0x6F736C6F: return "Purchase Orb of Slow";
        case 0x72726562: return "Purchase Rune of Rebirth";
        case 0x6473756D: return "Purchase Diamond of Summoning";
        case 0x736F7231: return "Purchase Shadow Orb";
        case 0x736F7232: return "Purchase Shadow Orb";
        case 0x736F7233: return "Purchase Shadow Orb";
        case 0x736F7234: return "Purchase Shadow Orb";
        case 0x736F7235: return "Purchase Shadow Orb";
        case 0x736F7236: return "Purchase Shadow Orb";
        case 0x736F7237: return "Purchase Shadow Orb";
        case 0x736F7238: return "Purchase Shadow Orb";
        case 0x736F7239: return "Purchase Shadow Orb";
        case 0x736F7261: return "Purchase Shadow Orb";
        case 0x736F7266: return "Purchase Shadow Orb Fragment";
        case 0x66777373: return "Purchase Frost Wyrm Skull Shield";
        case 0x676D6672: return "Purchase Gem Fragment";
        case 0x72616D31: return "Purchase Ring of the Archmagi";
        case 0x72616D32: return "Purchase Ring of the Archmagi";
        case 0x72616D33: return "Purchase Ring of the Archmagi";
        case 0x72616D34: return "Purchase Ring of the Archmagi";
        case 0x7368746D: return "Purchase Shamanic Totem";
        case 0x6573617A: return "Purchase Essence of Aszune";
        case 0x6A706E74: return "Purchase Note to Jaina Proudmoore";
        case 0x73687764: return "Purchase Shimmerweed";
        case 0x736B7274: return "Purchase Skeletal Artifact";
        case 0x74686C65: return "Purchase Thunder Lizard Egg";
        case 0x73636C70: return "Purchase Secret Level Powerup";
        case 0x676C646F: return "Purchase Orb of Kil'jaeden";
        case 0x77746C67: return "Purchase Wirt's Leg";
        case 0x776F6C67: return "Purchase Wirt's Other Leg";
        case 0x7462736D: return "Purchase Tiny Blacksmith";
        case 0x74666172: return "Purchase Tiny Farm";
        case 0x746C756D: return "Purchase Tiny Lumber Mill";
        case 0x74626172: return "Purchase Tiny Barracks";
        case 0x7462616B: return "Purchase Tiny Altar of Kings";
        case 0x6D67746B: return "Purchase Magic Key Chain";
        case 0x73747265: return "Purchase Staff of Reanimation";
        case 0x686F726C: return "Purchase Sacred Relic";
        case 0x68627468: return "Purchase Helm of Battlethirst";
        case 0x72756774: return "Purchase Runed Gauntlets";
        case 0x66726867: return "Purchase Firehand Gauntlets";
        case 0x6776736D: return "Purchase Gloves of Spell Mastery";
        case 0x63726474: return "Purchase Crown of the Deathlord";
        case 0x61727363: return "Purchase Arcane Scroll";
        case 0x7363756C: return "Purchase Scroll of the Unholy Legion";
        case 0x746D7363: return "Purchase Tome of Sacrifices";
        case 0x64747362: return "Purchase Drek'thar's Spellbook";
        case 0x6772736C: return "Purchase Grimoire of Souls";
        case 0x61727368: return "Purchase Arcanite Shield";
        case 0x73686474: return "Purchase Shield of the Deathlord";
        case 0x7368686E: return "Purchase Shield of Honor";
        case 0x7368656E: return "Purchase Enchanted Shield";
        case 0x7468646D: return "Purchase Thunderlizard Diamond";
        case 0x73747067: return "Purchase Clockwork Penguin";
        case 0x73687273: return "Purchase Shimmerglaze Roast";
        case 0x636F736C: return "Purchase Celestial Orb of Souls";
        case 0x73686377: return "Purchase Shaman Claws";
        case 0x73726264: return "Purchase Searing Blade";
        case 0x66726764: return "Purchase Frostguard";
        case 0x656E766C: return "Purchase Enchanted Vial";
        case 0x72756D70: return "Purchase Rusty Mining Pick";
        case 0x6D6F7274: return "Purchase Mogrin's Report";
        case 0x7372746C: return "Purchase Serathil";
        case 0x73747761: return "Purchase Sturdy War Axe";
        case 0x6B6C6D6D: return "Purchase Killmaim";
        case 0x726F7473: return "Purchase Scepter of the Sea";
        case 0x61786173: return "Purchase Ancestral Staff";
        case 0x6D6E7366: return "Purchase Mindstaff";
        case 0x7363686C: return "Purchase Scepter of Healing";
        case 0x6173626C: return "Purchase Assassin's Blade";
        case 0x6B67616C: return "Purchase Keg of Ale";
        case 0x64706865: return "Purchase Thunder Phoenix Egg";
        case 0x646B6677: return "Purchase Keg of Thunderwater";
        case 0x64746862: return "Purchase Thunderbloom Bulb";
        case 0x41496667: return "Cloud of Fog";
        case 0x41496379: return "Cyclone";
        case 0x41496F73: return "Slow";
        case 0x41556473: return "Dark Summoning";
        case 0x65676F6C: return "Entangle Gold Mine";
        case 0x6E736361: return "Hire Skeleton Archer";
        case 0x6E736365: return "Hire Skeleton Warrior";
        case 0x6E626132: return "Summon Doom Guard";
        case 0x4E74696E: return "Summon Tinker ";
        case 0x4E726F62: return "Summon Tinker ";
        case 0x6E636762: return "Summon Clockwerk Goblin";
        case 0x6E636731: return "Summon Clockwerk Goblin";
        case 0x6E636732: return "Summon Clockwerk Goblin";
        case 0x6E636733: return "Summon Clockwerk Goblin";
        case 0x6E666163: return "Summon Pocket Factory";
        case 0x6E666131: return "Summon Pocket Factory";
        case 0x6E666132: return "Summon Pocket Factory";
        case 0x41706732: return "Purge";
        case 0x41656772: return "Elune's Grace";
        case 0x41667232: return "Frost Attack";
        case 0x41616D32: return "Anti-magic Shell";
        case 0x41707332: return "Possession";
        case 0x414E7379: return "Pocket Factory";
        case 0x414E7331: return "Pocket Factory";
        case 0x414E7332: return "Pocket Factory";
        case 0x414E7333: return "Pocket Factory";
        case 0x414E6373: return "Cluster Rockets";
        case 0x414E6331: return "Cluster Rockets";
        case 0x414E6332: return "Cluster Rockets";
        case 0x414E6333: return "Cluster Rockets";
        case 0x414E6567: return "Engineering Upgrade";
        case 0x414E7267: return "Robo-Goblin";
        case 0x414E6731: return "Robo-Goblin";
        case 0x414E6732: return "Robo-Goblin";
        case 0x414E6733: return "Robo-Goblin";
        case 0x414E6465: return "Demolish";
        case 0x414E6431: return "Demolish";
        case 0x414E6432: return "Demolish";
        case 0x414E6433: return "Demolish";
        case 0x414E6679: return "Factory";
        case 0x414E6631: return "Factory";
        case 0x414E6632: return "Factory";
        case 0x414E6633: return "Factory";
        case 0x41736467: return "Kaboom!";
        case 0x41736432: return "Kaboom!";
        case 0x41736433: return "Kaboom!";
        case 0x41416E73: return "Charge Gold and Lumber";
        case 0x41457061: return "Poison Arrows";
        case 0x41456275: return "Build ";
        case 0x41476275: return "Build ";
        case 0x41486275: return "Build ";
        case 0x41486572: return "Hero";
        case 0x414E6275: return "Build ";
        case 0x414F6275: return "Build ";
        case 0x4152616C: return "Rally";
        case 0x41556275: return "Build ";
        case 0x41616C72: return "Alarm";
        case 0x4161746B: return "Attack";
        case 0x41666968: return "On Fire ";
        case 0x4166696E: return "On Fire ";
        case 0x4166696F: return "On Fire ";
        case 0x41666972: return "On Fire";
        case 0x41666975: return "On Fire ";
        case 0x416C6F63: return "Locust";
        case 0x416D6F76: return "Move";
        case 0x41746470: return "Drop Pilot";
        case 0x41746C70: return "Load Pilot";
        case 0x41747475: return "Turret";
    }
    return ID2Chars(id);
}
