#include <stdio.h>
#include <stdlib.h>
#include "../W3RepLib/W3RepAPI.h"

const char * Race2Str(Byte RaceID);

const char * MSec2Str(DWord MSec, char * Str);

int main(int argc, char * argv[])
{
    TW3RepFile rep;
    char TimeStr[9];
    char VersionStr[50];
    if(argc < 2)
    {
        printf("Usage: %s <replay filename>", argv[0]);
        return 0;
    }
    rep.Load(argv[1], COUNT_ACTIONS);
    printf("Version: %s\nMap:     %s\nCreator: %s\n\n", rep.Header.GetVersionString(VersionStr, true), rep.GameData.GetMapName(), rep.GameData.GetCreator());
    printf("%-6s%-18s%-6s%-7s%-11s%-13s%-9s%s\n", "Slot", "Player Name", "Team", "Color", "Race", "Played Time", "Actions", "APM");
    for(int i = 0; i < rep.GameData.GetPlayerCount(); i ++)
        if(rep.Player[i].GetSlotStatus() == slotstatus_used)
            if(rep.Player[i].GetTeam() < 12)
                printf("%-6u%-18s%-6u%-7u%-11s%-13s%-9u%.2f\n", i + 1, rep.Player[i].GetName(), rep.Player[i].GetTeam() + 1, rep.Player[i].GetColor() + 1, Race2Str(rep.Player[i].GetRace()), MSec2Str(rep.Player[i].GetPlayTime(), TimeStr), rep.Player[i].GetActions(), ((Float)rep.Player[i].GetActions()) * 60000.00 / ((Float)rep.Player[i].GetPlayTime()));
            else
                printf("%-6u%-18s%-24s%s\n", i + 1, rep.Player[i].GetName(), "Observer/Referee", MSec2Str(rep.Player[i].GetPlayTime(), TimeStr));
    rep.Unload();
    return 0;
}

const char * Race2Str(Byte RaceID)
{
    switch(RaceID)
    {
    case race_human: return "Human";
    case race_orc: return "Orc";
    case race_nightelf: return "Night Elf";
    case race_undead: return "Undead";
    case race_demon: return "Demon";
    case race_random: return "Random";
    default: return "Unknown";
    }
}

const char * MSec2Str(DWord MSec, char * Str)
{
    sprintf(Str, "%02u:%02u:%02u", MSec / 3600000, (MSec % 3600000) / 60000, (MSec % 60000) / 1000);
    return Str;
}
