#ifndef W3RepAPIH
#define W3RepAPIH

#include "W3RepGameData.h"
#include "W3RepPlayer.h"
#include "W3RepAction.h"
#include "W3RepDataType.h"

class TW3RepFile
{
public:
    TW3RepFile();
	virtual ~TW3RepFile();
	bool Load(const char * FileName, WRL_Byte options = COUNT_ACTIONS | ACTIONS_DETAIL | EXTRA_ACTIONS);
    void Unload();
    bool Loaded();
private:
    bool m_loaded;
    WRL_Byte m_playercount;
    WRL_Byte m_slotcount;
    WRL_Byte m_startspotcount;
    WRL_Byte m_playerindex[12];
public:
    TW3RepHeader Header;
    TW3RepGameData GameData;
    TW3RepActionList ActionList;
    TW3RepPlayer Player[12];
    WRL_Byte GetPlayerCount();
    WRL_Byte GetSlotCount();
    WRL_Byte GetStartSpotCount();
    WRL_Byte GetPlayerIndexByID(WRL_Byte playerid);
};

#endif