#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "W3RepAction.h"
#include "ID2Str.h"
#include "W3RepAPI.h"

typedef WRL_DWord UnitID;
typedef WRL_Float Pos[2];

const WRL_String Int2Str(WRL_DWord id)
{
    static unsigned char result[11];
    sprintf(result, "%d", id);
    return result;
}

#define ActionParamFunc(name) const WRL_String GetParamsAction_##name(const TW3RepAction * action) {\
    static unsigned char result[1024];\
    result[0] = 0;
#define ActionParamFuncEnd return result;\
}
ActionParamFunc(pause)
ActionParamFuncEnd
ActionParamFunc(resume)
ActionParamFuncEnd
ActionParamFunc(setspeed)
    static const WRL_String _SpeedString[3] = {
        "slow", "normal", "fast"
    };
    strcpy(result, _SpeedString[(WRL_DWord)*(WRL_Byte *)(action->GetParam(0)->data)]);
ActionParamFuncEnd
ActionParamFunc(incrspeed)
ActionParamFuncEnd
ActionParamFunc(decrspeed)
ActionParamFuncEnd
ActionParamFunc(savegame)
    strcpy(result, (WRL_String)(action->GetParam(0)->data));
ActionParamFuncEnd
ActionParamFunc(savefinish)
ActionParamFuncEnd
ActionParamFunc(ability_noparam)
    strcpy(result, ID2Str(*(WRL_DWord *)(action->GetParam(1)->data)));
ActionParamFuncEnd
ActionParamFunc(ability_pos)
    sprintf(result, "%s, (%.2f, %.2f)", ID2Str(*(WRL_DWord *)(action->GetParam(1)->data)), *(WRL_Float *)(action->GetParam(2)->data), *((WRL_Float *)(action->GetParam(2)->data) + 1));
ActionParamFuncEnd
ActionParamFunc(ability_posid)
    sprintf(result, "%s, (%.2f, %.2f), %s", ID2Str(*(WRL_DWord *)(action->GetParam(1)->data)), *(WRL_Float *)(action->GetParam(2)->data), *((WRL_Float *)(action->GetParam(2)->data) + 1), Int2Str(*(WRL_DWord *)(action->GetParam(3)->data)));
ActionParamFuncEnd
ActionParamFunc(giveitem)
    sprintf(result, "%s, (%.2f, %.2f), %s", ID2Str(*(WRL_DWord *)(action->GetParam(1)->data)), *(WRL_Float *)(action->GetParam(2)->data), *((WRL_Float *)(action->GetParam(2)->data) + 1), Int2Str(*(WRL_DWord *)(action->GetParam(3)->data)));
ActionParamFuncEnd
ActionParamFunc(ability_2posid)
    sprintf(result, "%s, (%.2f, %.2f), %s, (%.2f, %.2f)", ID2Str(*(WRL_DWord *)(action->GetParam(1)->data)), *(WRL_Float *)(action->GetParam(2)->data), *((WRL_Float *)(action->GetParam(2)->data) + 1), ID2Str(*(WRL_DWord *)(action->GetParam(3)->data)), *(WRL_Float *)(action->GetParam(4)->data), *((WRL_Float *)(action->GetParam(4)->data) + 1));
ActionParamFuncEnd
ActionParamFunc(selection)
    static const WRL_String _SelectionString[3] = {
        "", "Select", "Deselect"
    };
    int count = *(WRL_Word *)(action->GetParam(1)->data);
    sprintf(result, "%s %d units: %s", _SelectionString[(WRL_DWord)*(WRL_Byte *)(action->GetParam(0)->data)], count, Int2Str(*(WRL_DWord *)(action->GetParam(2)->data)));
    for(int i = 1; i < count; i ++)
    {
        strcat(result, ", ");
        strcat(result, Int2Str(*(WRL_DWord *)(action->GetParam(2 + i)->data)));
    }
ActionParamFuncEnd
ActionParamFunc(assign)
    int count = *(WRL_Word *)(action->GetParam(1)->data);
    sprintf(result, "To key %d, %d units: %s", (*(WRL_Byte *)(action->GetParam(0)->data)) % 10, count, Int2Str(*(WRL_DWord *)(action->GetParam(2)->data)));
    for(int i = 1; i < count; i ++)
    {
        strcat(result, ", ");
        strcat(result, Int2Str(*(WRL_DWord *)(action->GetParam(2 + i)->data)));
    }
ActionParamFuncEnd
ActionParamFunc(hotkey)
    sprintf(result, "Key %d", (*(WRL_Byte *)(action->GetParam(0)->data)) % 10);
ActionParamFuncEnd
ActionParamFunc(cheat1)
ActionParamFuncEnd
ActionParamFunc(cheat2)
ActionParamFuncEnd
ActionParamFunc(cheat3)
ActionParamFuncEnd
ActionParamFunc(cheat4)
ActionParamFuncEnd
ActionParamFunc(cheat5)
ActionParamFuncEnd
ActionParamFunc(cheat6)
ActionParamFuncEnd
ActionParamFunc(cheat7)
    sprintf(result, "%d", *(WRL_DWord *)(action->GetParam(0)->data));
ActionParamFuncEnd
ActionParamFunc(cheat8)
    sprintf(result, "%d", *(WRL_DWord *)(action->GetParam(0)->data));
ActionParamFuncEnd
ActionParamFunc(cheat9)
ActionParamFuncEnd
ActionParamFunc(cheat10)
ActionParamFuncEnd
ActionParamFunc(cheat11)
ActionParamFuncEnd
ActionParamFunc(cheat12)
ActionParamFuncEnd
ActionParamFunc(cheat13)
    sprintf(result, "%d", *(WRL_DWord *)(action->GetParam(0)->data));
ActionParamFuncEnd
ActionParamFunc(cheat14)
    sprintf(result, "%.2f", *(WRL_Float *)(action->GetParam(0)->data));
ActionParamFuncEnd
ActionParamFunc(cheat15)
ActionParamFuncEnd
ActionParamFunc(cheat16)
ActionParamFuncEnd
ActionParamFunc(cheat17)
ActionParamFuncEnd
ActionParamFunc(cheat18)
ActionParamFuncEnd
ActionParamFunc(changeally)
ActionParamFuncEnd
ActionParamFunc(transfer)
    TW3RepFile * rep = action->GetOwner();
    sprintf(result, "To %s, %d golds and %d lumber", rep->Player[rep->GetPlayerIndexByID(action->GetPlayerID())].GetName(), *(WRL_DWord *)(action->GetParam(1)->data), *(WRL_DWord *)(action->GetParam(2)->data));
ActionParamFuncEnd
ActionParamFunc(escpress)
ActionParamFuncEnd
ActionParamFunc(subgroup)
    sprintf(result, "%d", *(WRL_Byte *)(action->GetParam(0)->data));
ActionParamFuncEnd
ActionParamFunc(subgroup2)
ActionParamFuncEnd
ActionParamFunc(selectitem)
    sprintf(result, "%s", Int2Str(*(WRL_DWord *)(action->GetParam(0)->data)));
ActionParamFuncEnd
ActionParamFunc(selectitem2)
    sprintf(result, "%s", Int2Str(*(WRL_DWord *)(action->GetParam(0)->data)));
ActionParamFuncEnd
ActionParamFunc(cancelrevive)
    sprintf(result, "%s", Int2Str(*(WRL_DWord *)(action->GetParam(0)->data)));
ActionParamFuncEnd
ActionParamFunc(cancelrevive2)
    sprintf(result, "%s", Int2Str(*(WRL_DWord *)(action->GetParam(0)->data)));
ActionParamFuncEnd
ActionParamFunc(removequeue)
    sprintf(result, "unit %d, %s", (*(WRL_Byte *)(action->GetParam(0)->data)) + 1, Int2Str(*(WRL_DWord *)(action->GetParam(1)->data)));
ActionParamFuncEnd
ActionParamFunc(removequeue2)
    sprintf(result, "unit %d, %s", (*(WRL_Byte *)(action->GetParam(0)->data)) + 1, Int2Str(*(WRL_DWord *)(action->GetParam(1)->data)));
ActionParamFuncEnd
ActionParamFunc(chooseskill)
ActionParamFuncEnd
ActionParamFunc(choosebuild)
ActionParamFuncEnd
ActionParamFunc(chooseskill2)
ActionParamFuncEnd
ActionParamFunc(choosebuild2)
ActionParamFuncEnd
ActionParamFunc(signal)
    sprintf(result, "(%.2f, %.2f)", *(WRL_Float *)(action->GetParam(0)->data), *((WRL_Float *)(action->GetParam(0)->data) + 1));
ActionParamFuncEnd
ActionParamFunc(signal2)
    sprintf(result, "(%.2f, %.2f)", *(WRL_Float *)(action->GetParam(0)->data), *((WRL_Float *)(action->GetParam(0)->data) + 1));
ActionParamFuncEnd
ActionParamFunc(chat)
    switch(*(WRL_Byte *)action->GetParam(1)->data)
    {
        case 0: sprintf(result, "To All: %s", action->GetParam(1)->data); break;
        case 1: sprintf(result, "To Allies: %s", action->GetParam(1)->data); break;
        case 2: sprintf(result, "To Observers: %s", action->GetParam(1)->data); break;
        default:
        {
            TW3RepFile * rep = action->GetOwner();
            sprintf(result, "To %s: %s", rep->Player[rep->GetPlayerIndexByID(*(WRL_Byte *)action->GetParam(0)->data)].GetName(), action->GetParam(1)->data);
        }
    }
ActionParamFuncEnd
ActionParamFunc(leavegame)
ActionParamFuncEnd

TW3RepAction::~TW3RepAction()
{
    FreeParams();
}

void TW3RepAction::Initial(TW3RepFile * owner, TParamFunc paramfunc)
{
    m_id = aid_unknown;
    m_playerid = 0;
    m_time = 0;
    m_params = 0;
    m_paramcount = 0;
    m_owner = owner;
    m_paramfunc = paramfunc;
}

void TW3RepAction::FreeParams()
{
    if(m_params)
    {
        for(int i = 0; i < m_paramcount; i ++)
            if(m_params[i].data)
                free(m_params[i].data);
        free((void *)m_params);
        m_params = 0;
    }
    m_paramcount = 0;
}

TW3RepFile * TW3RepAction::GetOwner() const
{
    return m_owner;
}

TW3RepActionID TW3RepAction::GetID() const
{
    return m_id;
}

WRL_String TW3RepAction::GetName() const
{
    static const WRL_String _ActionNames0[] = {
        "", //0x00
        "Pause Game",
        "Resume Game",
        "Set Speed",
        "Increase Speed",
        "Decrease Speed",
        "Save Game",
        "Save Finish",
        "", //0x08
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "Action", //0x10
        "Action",
        "Action",
        "Give Item",
        "Action",
        "",
        "Select",
        "Assign Hotkey",
        "Hotkey Select", //0x18
        "Select Subgroup",
        "",
        "Select Item",
        "Cancel Revive",
        "Remove Queue",
        "",
        "",
        "Cheats: TheDudeAbides", //0x20
        "",
        "Cheats: SomebodySetUpUsTheBomb",
        "Cheats: WarpTen",
        "Cheats: IocainePowder",
        "Cheats: PointBreak",
        "Cheats: WhosYourDaddy",
        "Cheats: KeyserSoze",
        "Cheats: LeafitToMe", //0x28
        "Cheats: ThereIsNoSpoon",
        "Cheats: StrengthAndHonor",
        "Cheats: itvexesme",
        "Cheats: WhoIsJohnGalt",
        "Cheats: GreedIsGood",
        "Cheats: DayLightSavings",
        "Cheats: ISeeDeadPeople",
        "Cheats: Synergy", //0x30
        "Cheats: SharpAndShiny",
        "Cheats: AllYourBaseAreBelongToUs",
        "",
        "",
        "",
        "",
        "",
        "", //0x38
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "Chat", //0x40
        "Leave Game",
        "",
        "",
        "",
        "",
        "",
        "",
        "", //0x48
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "Change Ally", //0x50
        "Transfer Resource",
        "",
        "",
        "",
        "",
        "",
        "",
        "", //0x58
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "Trigger Info", //0x60
        "Press Esc",
        "Scenario Trigger",
        "",
        "",
        "Select Skill",
        "Select Building",
        "Map Signal",
        "", //0x68
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "", //0x70
        "",
        "",
        "",
        "",
        "",
        "",
        "",
    };
    static const WRL_String _ActionNames1[] = {
        "", //0x00
        "Pause Game",
        "Resume Game",
        "Set Speed",
        "Increase Speed",
        "Decrease Speed",
        "Save Game",
        "Save Finish",
        "", //0x08
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "Action", //0x10
        "Action",
        "Action",
        "Give Item",
        "Action",
        "",
        "Select",
        "Assign Hotkey",
        "Hotkey Select", //0x18
        "Select Subgroup",
        "",
        "Select Item",
        "Cancel Revive",
        "Remove Queue",
        "",
        "",
        "Cheats: TheDudeAbides", //0x20
        "",
        "Cheats: SomebodySetUpUsTheBomb",
        "Cheats: WarpTen",
        "Cheats: IocainePowder",
        "Cheats: PointBreak",
        "Cheats: WhosYourDaddy",
        "Cheats: KeyserSoze",
        "Cheats: LeafitToMe", //0x28
        "Cheats: ThereIsNoSpoon",
        "Cheats: StrengthAndHonor",
        "Cheats: itvexesme",
        "Cheats: WhoIsJohnGalt",
        "Cheats: GreedIsGood",
        "Cheats: DayLightSavings",
        "Cheats: ISeeDeadPeople",
        "Cheats: Synergy", //0x30
        "Cheats: SharpAndShiny",
        "Cheats: AllYourBaseAreBelongToUs",
        "",
        "",
        "",
        "",
        "",
        "", //0x38
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "Chat", //0x40
        "Leave Game",
        "",
        "",
        "",
        "",
        "",
        "",
        "", //0x48
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "Change Ally", //0x50
        "Transfer Resource",
        "",
        "",
        "",
        "",
        "",
        "",
        "", //0x58
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "Trigger Info", //0x60
        "Press Esc",
        "Scenario Trigger",
        "",
        "",
        "",
        "Select Skill",
        "Select Building",
        "Map Signal", //0x68
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "", //0x70
        "",
        "",
        "",
        "",
        "",
        "",
        "",
    };
    static const WRL_String _ActionNames2[] = {
        "", //0x00
        "Pause Game",
        "Resume Game",
        "Set Speed",
        "Increase Speed",
        "Decrease Speed",
        "Save Game",
        "Save Finish",
        "", //0x08
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "Action", //0x10
        "Action",
        "Action",
        "Give Item",
        "Action",
        "",
        "Select",
        "Assign Hotkey",
        "Hotkey Select", //0x18
        "",
        "Select Subgroup",
        "",
        "Select Item",
        "Cancel Revive",
        "Remove Queue",
        "",
        "Cheats: TheDudeAbides", //0x20
        "",
        "Cheats: SomebodySetUpUsTheBomb",
        "Cheats: WarpTen",
        "Cheats: IocainePowder",
        "Cheats: PointBreak",
        "Cheats: WhosYourDaddy",
        "Cheats: KeyserSoze",
        "Cheats: LeafitToMe", //0x28
        "Cheats: ThereIsNoSpoon",
        "Cheats: StrengthAndHonor",
        "Cheats: itvexesme",
        "Cheats: WhoIsJohnGalt",
        "Cheats: GreedIsGood",
        "Cheats: DayLightSavings",
        "Cheats: ISeeDeadPeople",
        "Cheats: Synergy", //0x30
        "Cheats: SharpAndShiny",
        "Cheats: AllYourBaseAreBelongToUs",
        "",
        "",
        "",
        "",
        "",
        "", //0x38
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "Chat", //0x40
        "Leave Game",
        "",
        "",
        "",
        "",
        "",
        "",
        "", //0x48
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "Change Ally", //0x50
        "Transfer Resource",
        "",
        "",
        "",
        "",
        "",
        "",
        "", //0x58
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "Trigger Info", //0x60
        "Press Esc",
        "Scenario Trigger",
        "",
        "",
        "",
        "Select Skill",
        "Select Building",
        "Map Signal", //0x68
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "", //0x70
        "",
        "",
        "",
        "",
        "",
        "",
        "",
    };
    if(m_owner->Header.GetBuild() < 6000)
        return _ActionNames0[m_id];
    if(m_owner->Header.GetBuild() < 6040)
        return _ActionNames1[m_id];
    return _ActionNames2[m_id];
}

WRL_Byte TW3RepAction::GetPlayerID() const
{
    return m_playerid;
}

WRL_DWord TW3RepAction::GetTime() const
{
    return m_time;
}

void TW3RepAction::SetID(TW3RepActionID aid)
{
    m_id = aid;
}

bool TW3RepAction::SetPlayerID(WRL_Byte playerid)
{
    if(playerid == 0 || playerid > 12)
        return false;
    m_playerid = playerid;
    return true;
}

void TW3RepAction::SetTime(WRL_DWord time)
{
    m_time = time;
}

void TW3RepAction::AddParam(TW3RepActionParamType type, WRL_String &data, WRL_Word &size)
{
    WRL_Word len;
    if(m_paramcount == 0) {
        m_params = (TW3RepActionParam *)malloc(sizeof(TW3RepActionParam));
    }else{
        m_params = (TW3RepActionParam *)realloc(m_params, (m_paramcount + 1) * sizeof(TW3RepActionParam));
    }
    m_params[m_paramcount].type = type;
    switch(type)
    {
    case ParamType_WRL_Byte:
        m_params[m_paramcount].data = malloc(1);
        *(WRL_String )m_params[m_paramcount].data = * data;
        data ++;
        size --;
        break;
    case ParamType_WRL_Word:
        m_params[m_paramcount].data = malloc(2);
        *(WRL_Word *)m_params[m_paramcount].data = *(WRL_Word *)data;
        data += 2;
        size -= 2;
        break;
    case ParamType_UnitID:
        m_params[m_paramcount].data = malloc(4);
        *(WRL_DWord *)m_params[m_paramcount].data = *(WRL_DWord *)data;
        data += 4;
        size -= 4;
        break;
    case ParamType_WRL_DWord:
        m_params[m_paramcount].data = malloc(4);
        *(WRL_DWord *)m_params[m_paramcount].data = *(WRL_DWord *)data;
        data += 4;
        size -= 4;
        break;
    case ParamType_WRL_Float:
        m_params[m_paramcount].data = malloc(4);
        *(float *)m_params[m_paramcount].data = *(float *)data;
        data += 4;
        size -= 4;
        break;
    case ParamType_Pos:
        m_params[m_paramcount].data = malloc(8);
        memcpy(m_params[m_paramcount].data, data, 8);
        data += 8;
        size -= 8;
        break;
    case ParamType_WRL_String:
        m_params[m_paramcount].data = (void *)strdup((char *)data);
        len = (WRL_Word)strlen((char *)data) + 1;
        data += len;
        size -= len;
        break;
    default:
        return;
    }
    m_paramcount ++;
}

WRL_Byte TW3RepAction::GetParamCount()
{
    return m_paramcount;
}

TW3RepActionParam * TW3RepAction::GetParam(WRL_DWord index) const
{
    return &m_params[index];
}

const WRL_String TW3RepAction::GetParamString() const
{
    if(m_paramfunc)
        return m_paramfunc(this);
    else
        return "";
}

TW3RepActionList::~TW3RepActionList()
{
    Unload();
}

bool TW3RepActionList::Load(TW3RepFile * owner, WRL_String &data, bool actiondetail, bool extraaction, WRL_Word gamebuild)
{
    WRL_DWord time = 0;
    bool paused = false;
    bool started = false;
    if(m_loaded)
        Unload();
    m_owner = owner;
    m_actiondetail = actiondetail;
    m_extraaction = extraaction;
    m_gamebuild = gamebuild;
    while(ProcessActionBlock(data, time, paused, started)) {}
    m_loaded = true;
    return true;
}

void TW3RepActionList::Unload()
{
    if(!m_loaded)
        return;
    m_loaded = false;
    m_owner = NULL;
    m_actiondetail = false;
    m_extraaction = false;
    m_alloccount = 0;
    m_actioncount = 0;
    m_blockcount = 0;
    for(WRL_DWord i = 0; i < m_actioncount; i ++)
        m_actions[i].FreeParams();
    if(m_actions)
    {
        free((void *)m_actions);
        m_actions = 0;
    }
}

bool TW3RepActionList::Loaded() const
{
    return m_loaded;
}

#define PROCESS_BLOCKS_START switch(*data) {
#define PROCESS_BLOCK(block,size) case (block):\
    data += (size);
#define PROCESS_BLOCK2(block1,block2,size) case (block1):case (block2):\
    data += (size);
#define PROCESS_BLOCK_END m_blockcount++;\
    break;
#define PROCESS_BLOCKS_END default: return false;\
    }

enum {
    bid_end = 0x0,
    bid_leave = 0x17,
    bid_block1 = 0x1A,
    bid_block2 = 0x1B,
    bid_block3 = 0x1C,
    bid_actions = 0x1E,
    bid_actions2 = 0x1F,
    bid_chat = 0x20,
    bid_unknown1 = 0x22,
    bid_unknown2 = 0x23,
    bid_forceend = 0x2F
};

bool TW3RepActionList::ProcessActionBlock(WRL_String &data, WRL_DWord &time, bool &paused, bool &started)
{
    WRL_Word psize;
    WRL_DWord passtime;
    TW3RepAction * action;
    WRL_Byte * p;
    PROCESS_BLOCKS_START
        PROCESS_BLOCK(bid_leave, 14)
            p = data - 9;
            action = AddAction(aid_leavegame, * p, time, GetParamsAction_leavegame);
            psize = 13;
            p -= 4;
            action->AddParam(ParamType_WRL_DWord, p, psize);
            p += 1;
            action->AddParam(ParamType_WRL_DWord, p, psize);
            if(m_ProcessActionCB)
                m_ProcessActionCB(m_owner, action, false);
        PROCESS_BLOCK_END
        PROCESS_BLOCK2(bid_block1,bid_block2,5)
        PROCESS_BLOCK_END
        PROCESS_BLOCK(bid_block3,5)
            started = true;
        PROCESS_BLOCK_END
        PROCESS_BLOCK2(bid_actions,bid_actions2,5)
            psize = (*(WRL_Word *)(data - 4)) - 2;
            passtime = (WRL_DWord)(*(WRL_Word *)(data - 2));
            while(psize > 0)
                ProcessAction(data, psize, time, paused);
            if(!paused)
                time += passtime;
        PROCESS_BLOCK_END
        PROCESS_BLOCK(bid_chat,5)
            if(started)
            {
                action = AddAction(aid_chat, *(data - 4), time, GetParamsAction_chat);
                psize = 4;
                action->AddParam(ParamType_WRL_DWord, data, psize);
                psize = 255;
                action->AddParam(ParamType_WRL_String, data, psize);
                if(m_ProcessActionCB)
                    m_ProcessActionCB(m_owner, action, false);
            }
            else
                data += strlen(data) + 1;
        PROCESS_BLOCK_END
        PROCESS_BLOCK(bid_unknown1,6)
        PROCESS_BLOCK_END
        PROCESS_BLOCK(bid_unknown2,11)
        PROCESS_BLOCK_END
        PROCESS_BLOCK(bid_forceend,9)
        PROCESS_BLOCK_END
    PROCESS_BLOCKS_END

    return true;
}

#define PROCESS_ACTIONS_BEGIN switch(*p) {
#define PROCESS_ACTION_BEGIN_CONDITION(acid,condition,frlast,ifcount) case aid_##acid: {\
    TW3RepAction * action;\
    if(frlast || condition) {\
        if(frlast)\
        {\
            action = &m_actions[m_actioncount - 1];\
            action->FreeParams();\
        }\
        else {\
            action = AddAction(aid_##acid, playerid, time, GetParamsAction_##acid);\
            if(ifcount && m_ProcessActionCB)\
                m_ProcessActionCB(m_owner, action, ifcount);\
        }\
        if(m_actiondetail) {\
            p ++;\
            bsize --;
#define PROCESS_ACTION_BEGIN(acid) case aid_##acid: {\
    TW3RepAction * action;\
    action = AddAction(aid_##acid, playerid, time, GetParamsAction_##acid);\
    if(m_ProcessActionCB)\
        m_ProcessActionCB(m_owner, action, true);\
    if(m_actiondetail) {\
        p ++;\
        bsize --;
#define PROCESS_ACTION_NOCOUNT(aid,asize) case aid_##aid:\
    p += asize;\
    bsize -= asize;\
    break;
#define PROCESS_ACTION_SKIP_PARAM(psize) {\
        if(bsize < psize)\
        {\
            bsize = 0;\
            continue;\
        }\
        p += psize;\
        if(bsize > psize)\
            bsize -= psize;\
        else\
            bsize = 0;\
    }
#define PROCESS_ACTION_PARAM(type) if(bsize < sizeof(type))\
    {\
        bsize = 0;\
        continue;\
    }\
    action->AddParam(ParamType_##type, p, bsize);
#define PROCESS_ACTION_END_CONDITION(tsize) }\
        else {\
            if(bsize > (tsize))\
                bsize -= (tsize);\
            else\
                bsize = 0;\
            p += (tsize);\
        }\
    }\
    else {\
        if(bsize > (tsize))\
            bsize -= (tsize);\
        else\
            bsize = 0;\
        p += (tsize);\
    }\
    continue; }
#define PROCESS_ACTION_END(tsize) }\
    else {\
        if(bsize > (tsize))\
            bsize -= (tsize);\
        else\
            bsize = 0;\
        p += (tsize);\
    }\
    continue; }
#define PROCESS_ACTIONS_END }
#define PROCESS_ACTIONS_END2 default:\
        bsize = 0;\
        continue;\
    }

void TW3RepActionList::ProcessAction(WRL_String &data, WRL_Word &size, WRL_DWord time, bool &paused)
{
    WRL_Byte playerid;
    WRL_Word bsize;
    WRL_String p;
    bool lastisdesel;
    bool lastisupdate;
    bool vlastisdesel = false;
    bool vlastisupdate = false;
    WRL_Word count;
    WRL_Word i;

    playerid = *data;
    data ++;
    bsize = *(WRL_Word *)data;
    data += 2;
    p = data;
    data += bsize;
    size -= (bsize + 3);
    while(bsize > 0)
    {
        lastisdesel = vlastisdesel;
        lastisupdate = vlastisupdate;
        if(*p == aid_pause)
            paused = true;
        else if(*p == aid_resume)
            paused = false;
        else if(bsize > 1) {
            if(*p == aid_selection && (*(p + 1)) == 0x02)
                vlastisdesel = true;
            else
                vlastisdesel = false;
            if(*p == aid_subgroup && (*(p + 1)) == 0xff)
                vlastisupdate = true;
            else
                vlastisupdate = false;
        }
        PROCESS_ACTIONS_BEGIN
            PROCESS_ACTION_BEGIN_CONDITION(pause,m_extraaction,false,false)
            PROCESS_ACTION_END_CONDITION(1)
            PROCESS_ACTION_BEGIN_CONDITION(resume,m_extraaction,false,false)
            PROCESS_ACTION_END_CONDITION(1)
            PROCESS_ACTION_BEGIN_CONDITION(setspeed,m_extraaction,false,false)
                PROCESS_ACTION_PARAM(WRL_Byte)
            PROCESS_ACTION_END_CONDITION(2)
            PROCESS_ACTION_BEGIN_CONDITION(incrspeed,m_extraaction,false,false)
            PROCESS_ACTION_END_CONDITION(1)
            PROCESS_ACTION_BEGIN_CONDITION(decrspeed,m_extraaction,false,false)
            PROCESS_ACTION_END_CONDITION(1)
            PROCESS_ACTION_BEGIN_CONDITION(savegame,m_extraaction,false,false)
                PROCESS_ACTION_PARAM(WRL_String)
            PROCESS_ACTION_END_CONDITION(2 + (WRL_Word)strlen((char *)(p + 1)))
            PROCESS_ACTION_BEGIN_CONDITION(savefinish,m_extraaction,false,false)
                PROCESS_ACTION_SKIP_PARAM(4)
            PROCESS_ACTION_END_CONDITION(5)
            PROCESS_ACTION_BEGIN(ability_noparam)
                if(m_gamebuild >= 6037) {
                    PROCESS_ACTION_PARAM(WRL_Word)
                } else {
                    PROCESS_ACTION_PARAM(WRL_Byte)
                }
                PROCESS_ACTION_PARAM(UnitID)
                if(m_gamebuild >= 6000)
                    PROCESS_ACTION_SKIP_PARAM(8)
            PROCESS_ACTION_END((m_gamebuild >= 6037) ? 15 : ((m_gamebuild >= 6000) ? 14 : 6));
            PROCESS_ACTION_BEGIN(ability_pos)
                if(m_gamebuild >= 6037) {
                    PROCESS_ACTION_PARAM(WRL_Word)
                } else {
                    PROCESS_ACTION_PARAM(WRL_Byte)
                }
                PROCESS_ACTION_PARAM(UnitID)
                if(m_gamebuild >= 6000)
                    PROCESS_ACTION_SKIP_PARAM(8)
                PROCESS_ACTION_PARAM(Pos)
            PROCESS_ACTION_END((m_gamebuild >= 6037) ? 23 : ((m_gamebuild >= 6000) ? 22 : 14));
            PROCESS_ACTION_BEGIN(ability_posid)
                if(m_gamebuild >= 6037) {
                    PROCESS_ACTION_PARAM(WRL_Word)
                } else {
                    PROCESS_ACTION_PARAM(WRL_Byte)
                }
                PROCESS_ACTION_PARAM(UnitID)
                if(m_gamebuild >= 6000)
                    PROCESS_ACTION_SKIP_PARAM(8)
                PROCESS_ACTION_PARAM(Pos)
                PROCESS_ACTION_PARAM(UnitID)
                PROCESS_ACTION_PARAM(UnitID)
            PROCESS_ACTION_END((m_gamebuild >= 6037) ? 31 : ((m_gamebuild >= 6000) ? 30 : 22));
            PROCESS_ACTION_BEGIN(giveitem)
                if(m_gamebuild >= 6037) {
                    PROCESS_ACTION_PARAM(WRL_Word)
                } else {
                    PROCESS_ACTION_PARAM(WRL_Byte)
                }
                PROCESS_ACTION_PARAM(UnitID)
                if(m_gamebuild >= 6000)
                    PROCESS_ACTION_SKIP_PARAM(8)
                PROCESS_ACTION_PARAM(Pos)
                PROCESS_ACTION_PARAM(UnitID)
                PROCESS_ACTION_PARAM(UnitID)
                PROCESS_ACTION_PARAM(UnitID)
                PROCESS_ACTION_PARAM(UnitID)
            PROCESS_ACTION_END((m_gamebuild >= 6037) ? 39 : ((m_gamebuild >= 6000) ? 38 : 30));
            PROCESS_ACTION_BEGIN(ability_2posid)
                if(m_gamebuild >= 6037) {
                    PROCESS_ACTION_PARAM(WRL_Word)
                } else {
                    PROCESS_ACTION_PARAM(WRL_Byte)
                }
                PROCESS_ACTION_PARAM(UnitID)
                if(m_gamebuild >= 6000)
                    PROCESS_ACTION_SKIP_PARAM(8)
                PROCESS_ACTION_PARAM(Pos)
                PROCESS_ACTION_PARAM(UnitID)
                PROCESS_ACTION_SKIP_PARAM(9)
                PROCESS_ACTION_PARAM(Pos)
            PROCESS_ACTION_END((m_gamebuild >= 6037) ? 44 : ((m_gamebuild >= 6000) ? 43 : 35));
            PROCESS_ACTION_BEGIN_CONDITION(selection,!lastisdesel,lastisdesel,true)
                PROCESS_ACTION_PARAM(WRL_Byte)
                count = *(WRL_Word *)p;
                PROCESS_ACTION_PARAM(WRL_Word)
                for(i = 0; i < count; i ++)
                {
                    PROCESS_ACTION_PARAM(UnitID)
                    PROCESS_ACTION_PARAM(UnitID)
                }
            PROCESS_ACTION_END_CONDITION(4 + 8 * (*(WRL_Word *)(p + 2)))
            PROCESS_ACTION_BEGIN(assign)
                PROCESS_ACTION_PARAM(WRL_Byte)
                count = *(WRL_Word *)p;
                PROCESS_ACTION_PARAM(WRL_Word)
                for(i = 0; i < count; i ++)
                {
                    PROCESS_ACTION_PARAM(UnitID)
                    PROCESS_ACTION_PARAM(UnitID)
                }
            PROCESS_ACTION_END(4 + 8 * (*(WRL_Word *)(p + 2)))
            PROCESS_ACTION_BEGIN(hotkey)
                PROCESS_ACTION_PARAM(WRL_Byte)
                PROCESS_ACTION_SKIP_PARAM(1)
            PROCESS_ACTION_END(3)
            PROCESS_ACTION_NOCOUNT(unknown21, 9)
            PROCESS_ACTION_BEGIN_CONDITION(cheat1,m_extraaction,false,false)
            PROCESS_ACTION_END_CONDITION(1)
            PROCESS_ACTION_BEGIN_CONDITION(cheat2,m_extraaction,false,false)
            PROCESS_ACTION_END_CONDITION(1)
            PROCESS_ACTION_BEGIN_CONDITION(cheat3,m_extraaction,false,false)
            PROCESS_ACTION_END_CONDITION(1)
            PROCESS_ACTION_BEGIN_CONDITION(cheat4,m_extraaction,false,false)
            PROCESS_ACTION_END_CONDITION(1)
            PROCESS_ACTION_BEGIN_CONDITION(cheat5,m_extraaction,false,false)
            PROCESS_ACTION_END_CONDITION(1)
            PROCESS_ACTION_BEGIN_CONDITION(cheat6,m_extraaction,false,false)
            PROCESS_ACTION_END_CONDITION(1)
            PROCESS_ACTION_BEGIN_CONDITION(cheat7,m_extraaction,false,false)
                PROCESS_ACTION_SKIP_PARAM(1)
                PROCESS_ACTION_PARAM(WRL_DWord)
            PROCESS_ACTION_END_CONDITION(6)
            PROCESS_ACTION_BEGIN_CONDITION(cheat8,m_extraaction,false,false)
                PROCESS_ACTION_SKIP_PARAM(1)
                PROCESS_ACTION_PARAM(WRL_DWord)
            PROCESS_ACTION_END_CONDITION(6)
            PROCESS_ACTION_BEGIN_CONDITION(cheat9,m_extraaction,false,false)
            PROCESS_ACTION_END_CONDITION(1)
            PROCESS_ACTION_BEGIN_CONDITION(cheat10,m_extraaction,false,false)
            PROCESS_ACTION_END_CONDITION(1)
            PROCESS_ACTION_BEGIN_CONDITION(cheat11,m_extraaction,false,false)
            PROCESS_ACTION_END_CONDITION(1)
            PROCESS_ACTION_BEGIN_CONDITION(cheat12,m_extraaction,false,false)
            PROCESS_ACTION_END_CONDITION(1)
            PROCESS_ACTION_BEGIN_CONDITION(cheat13,m_extraaction,false,false)
                PROCESS_ACTION_SKIP_PARAM(1)
                PROCESS_ACTION_PARAM(WRL_DWord)
            PROCESS_ACTION_END_CONDITION(6)
            PROCESS_ACTION_BEGIN_CONDITION(cheat14,m_extraaction,false,false)
                PROCESS_ACTION_PARAM(WRL_Float)
            PROCESS_ACTION_END_CONDITION(5)
            PROCESS_ACTION_BEGIN_CONDITION(cheat15,m_extraaction,false,false)
            PROCESS_ACTION_END_CONDITION(1)
            PROCESS_ACTION_BEGIN_CONDITION(cheat16,m_extraaction,false,false)
            PROCESS_ACTION_END_CONDITION(1)
            PROCESS_ACTION_BEGIN_CONDITION(cheat17,m_extraaction,false,false)
            PROCESS_ACTION_END_CONDITION(1)
            PROCESS_ACTION_BEGIN_CONDITION(cheat18,m_extraaction,false,false)
            PROCESS_ACTION_END_CONDITION(1)
            PROCESS_ACTION_BEGIN_CONDITION(changeally,m_extraaction,false,false)
                PROCESS_ACTION_PARAM(WRL_Byte)
                PROCESS_ACTION_PARAM(WRL_DWord)
            PROCESS_ACTION_END_CONDITION(6)
            PROCESS_ACTION_BEGIN_CONDITION(transfer,m_extraaction,false,false)
                PROCESS_ACTION_PARAM(WRL_Byte)
                PROCESS_ACTION_PARAM(WRL_DWord)
                PROCESS_ACTION_PARAM(WRL_DWord)
            PROCESS_ACTION_END_CONDITION(10)
            PROCESS_ACTION_NOCOUNT(trigger, (WRL_Word)strlen((char *)(p + 9)) + 10)
            PROCESS_ACTION_BEGIN(escpress)
            PROCESS_ACTION_END(1)
            PROCESS_ACTION_NOCOUNT(scentrigger, ((m_gamebuild >= 6000) ? 13 : 9))
            PROCESS_ACTION_NOCOUNT(unknown75, 2)
        PROCESS_ACTIONS_END
        if(m_gamebuild >= 6000)
        {
            if(m_gamebuild >= 6040)
            {
                PROCESS_ACTIONS_BEGIN
                    PROCESS_ACTION_BEGIN_CONDITION(subgroup2,m_extraaction,false,false)
                        if(*p == 0x19)
                        {
                            PROCESS_ACTION_SKIP_PARAM(1)
                            PROCESS_ACTION_PARAM(UnitID)
                            PROCESS_ACTION_PARAM(UnitID)
                            PROCESS_ACTION_PARAM(UnitID)
                        }
                        else
                            PROCESS_ACTION_SKIP_PARAM(1)
                    PROCESS_ACTION_END_CONDITION((((*(p + 1)) == 0x19) ? 14 : 2))
                    PROCESS_ACTION_NOCOUNT(unknown1B, 10);
                    PROCESS_ACTION_BEGIN(selectitem2)
                        PROCESS_ACTION_SKIP_PARAM(1)
                        PROCESS_ACTION_PARAM(UnitID)
                        PROCESS_ACTION_PARAM(UnitID)
                    PROCESS_ACTION_END(10)
                    PROCESS_ACTION_BEGIN(cancelrevive2)
                        PROCESS_ACTION_PARAM(UnitID)
                        PROCESS_ACTION_PARAM(UnitID)
                    PROCESS_ACTION_END(9)
                    PROCESS_ACTION_BEGIN(removequeue2)
                        PROCESS_ACTION_PARAM(WRL_Byte)
                        PROCESS_ACTION_PARAM(UnitID)
                    PROCESS_ACTION_END(6)
                PROCESS_ACTIONS_END
            }
            else
            {
                PROCESS_ACTIONS_BEGIN
                    PROCESS_ACTION_BEGIN_CONDITION(subgroup,(*(p+1) != 0x0 && *(p+1) != 0xFF && !lastisupdate),lastisupdate,true)
                        PROCESS_ACTION_PARAM(WRL_Byte)
                    PROCESS_ACTION_END_CONDITION(2)
                    PROCESS_ACTION_NOCOUNT(unknown1A, 10);
                    PROCESS_ACTION_BEGIN(selectitem)
                        PROCESS_ACTION_SKIP_PARAM(1)
                        PROCESS_ACTION_PARAM(UnitID)
                        PROCESS_ACTION_PARAM(UnitID)
                    PROCESS_ACTION_END(10)
                    PROCESS_ACTION_BEGIN(cancelrevive)
                        PROCESS_ACTION_PARAM(UnitID)
                        PROCESS_ACTION_PARAM(UnitID)
                    PROCESS_ACTION_END(9)
                    PROCESS_ACTION_BEGIN(removequeue)
                        PROCESS_ACTION_PARAM(WRL_Byte)
                        PROCESS_ACTION_PARAM(UnitID)
                    PROCESS_ACTION_END(6)
                PROCESS_ACTIONS_END
            }
            PROCESS_ACTIONS_BEGIN
                PROCESS_ACTION_BEGIN(chooseskill2)
                PROCESS_ACTION_END(1)
                PROCESS_ACTION_BEGIN(choosebuild2)
                PROCESS_ACTION_END(1)
                PROCESS_ACTION_BEGIN_CONDITION(signal2,m_extraaction,false,false)
                    PROCESS_ACTION_PARAM(Pos)
                    PROCESS_ACTION_SKIP_PARAM(4)
                PROCESS_ACTION_END_CONDITION(13)
                PROCESS_ACTION_NOCOUNT(continueB2,17)
                PROCESS_ACTION_NOCOUNT(continueA2,17)
            PROCESS_ACTIONS_END2
        }
        else
        {
            PROCESS_ACTIONS_BEGIN
                PROCESS_ACTION_BEGIN(chooseskill)
                PROCESS_ACTION_END(1)
                PROCESS_ACTION_BEGIN(choosebuild)
                PROCESS_ACTION_END(1)
                PROCESS_ACTION_BEGIN_CONDITION(signal,m_extraaction,false,false)
                    PROCESS_ACTION_PARAM(Pos)
                    PROCESS_ACTION_SKIP_PARAM(4)
                PROCESS_ACTION_END_CONDITION(13)
                PROCESS_ACTION_NOCOUNT(continueB, 17)
                PROCESS_ACTION_NOCOUNT(continueA, 17)
            PROCESS_ACTIONS_END2
        }
    }
}

TW3RepAction * TW3RepActionList::AddAction(TW3RepActionID aid, WRL_Byte playerid, WRL_DWord time, TParamFunc paramfunc)
{
    if(m_alloccount == 0)
    {
        m_alloccount = 500;
        m_actions = (TW3RepAction *)malloc(m_alloccount * sizeof(TW3RepAction));
    }
    if(m_actioncount >= m_alloccount)
    {
        m_alloccount += 500;
        m_actions = (TW3RepAction *)realloc(m_actions, m_alloccount * sizeof(TW3RepAction));
    }
    m_actions[m_actioncount].Initial(m_owner, paramfunc);
    m_actions[m_actioncount].SetID(aid);
    m_actions[m_actioncount].SetPlayerID(playerid);
    m_actions[m_actioncount].SetTime(time);
    m_actioncount ++;
    return &m_actions[m_actioncount - 1];
}

WRL_DWord TW3RepActionList::GetActionCount() const
{
    return m_actioncount;
}

WRL_DWord TW3RepActionList::GetBlockCount() const
{
    return m_blockcount;
}

TW3RepAction * TW3RepActionList::GetAction(WRL_DWord index) const
{
    return &m_actions[index];
}

void TW3RepActionList::SetProcessActionCallBack(TProcessActionCallBack cb)
{
    m_ProcessActionCB = cb;
}

