#ifndef W3RepPlayerH
#define W3RepPlayerH
#include "W3RepDataType.h"

enum {
    race_unknown = 0,
    race_human = 1,
    race_orc = 2,
    race_nightelf = 3,
    race_undead = 4,
    race_demon = 5,
    race_random = 8
};

typedef enum {
    slotstatus_open = 0,
    slotstatus_closed = 1,
    slotstatus_used = 2
} TSlotStatus;

typedef enum {
    computerai_easy = 0,
    computerai_normal = 1,
    computerai_insane = 2
} TComputerAI;

class TW3RepPlayer
{
public:
    TW3RepPlayer();
    virtual ~TW3RepPlayer();
    bool Load1(WRL_String &data, bool * ladder);
    bool Load2(WRL_String &data, WRL_DWord version);
    void Unload();
    bool Loaded() const;
private:
    bool m_loaded;
    WRL_Byte m_id;
    const char * m_name;
    TSlotStatus m_slotstatus;
    bool m_computer;
    WRL_Byte m_team;
    WRL_Byte m_color;
    WRL_Byte m_race;
    TComputerAI m_ai;
    WRL_Byte m_handicap;
    WRL_Byte m_slotcount;
    WRL_DWord m_playtime;
    WRL_DWord m_actions;
    WRL_Byte GetRaceID(WRL_Byte raceid);
public:
    WRL_Byte GetID() const;
    const char * GetName() const;
    TSlotStatus GetSlotStatus() const;
    bool GetComputer() const;
    WRL_Byte GetTeam() const;
    WRL_Byte GetColor() const;
    WRL_Byte GetRace() const;
    TComputerAI GetAI() const;
    WRL_Byte GetHandicap() const;
    WRL_DWord GetPlayTime() const;
    WRL_DWord GetActions() const;
    bool SetID(WRL_Byte id);
    bool SetName(const char * name);
    bool SetSlotStatus(TSlotStatus slotstatus);
    void SetComputer(bool computer);
    bool SetTeam(WRL_Byte team);
    bool SetColor(WRL_Byte color);
    bool SetRace(WRL_Byte race);
    bool SetAI(TComputerAI ai);
    bool SetHandicap(WRL_Byte handicap);
    void SetPlayTime(WRL_DWord playtime);
    void SetActions(WRL_DWord actions);
    void IncrAction();
};

#endif